/*    
 *  Copyright 2000, 2001, 2002 Emmanuel Benazera  
 *
 *  This file is part of Koala.
 *
 *  Koala is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  Koala is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with Koala; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#include "CondVar.h"
#include <iostream>

using namespace std;

/* constructors. */

CondVar::CondVar(string name, set<string> se, string defa, Comp* co) : StateVar(name, se, defa, co) {
  type = "Cond";
  conditions = new vector<cond>();
  vars = new vector<variable>();
  guards_number = 0;
}
CondVar::CondVar(string name, set<string> se, string defa, Comp* co, bool obs) : StateVar(name, se, defa, co) {
  type = "Cond";
  conditions = new vector<cond>();
  vars = new vector<variable>();
  guards_number = 0;
}
CondVar::CondVar() : StateVar() {
  type = "Cond";
  guards_number = 0;
  conditions = new vector<cond>();
  vars = new vector<variable>();
}
CondVar::~CondVar() {
  delete conditions;
  delete vars;
}
void CondVar::showConditions () {
  cout << "\t\t{ ";
  for (unsigned int i=0; i<conditions->size (); i++) {
    printCondition ((*conditions)[i]);
    cout << " ";
  }
  cout << "}\n";
}
