/*    
 *  Copyright 2000, 2001, 2002 Emmanuel Benazera  
 *
 *  This file is part of Koala.
 *
 *  Koala is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  Koala is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with Koala; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#include "MapFunc.h"
#include <iostream>

MapFunc::MapFunc (vector<mapfVar>* v) {
  condi = NULL;
  mvs = new vector<mapfVar>();
  for (unsigned int i=0; i<v->size(); i++)
    mvs->push_back ((*v)[i]);
}

MapFunc::MapFunc (cond cd, vector<mapfVar>* v) {
  condi = cd;
  mvs = new vector<mapfVar>();
  for (unsigned int i=0; i<v->size(); i++)
    mvs->push_back ((*v)[i]);
}

MapFunc::~MapFunc () {
  delete mvs;
}

void MapFunc::showMapFunc () {
  if (mvs != NULL) {
    if (condi != NULL)
      printCondition (condi);
    for (unsigned int i=0; i<mvs->size(); i++) {
      cout << "\t\t" << getMFVarName ((*mvs)[i]) << " = ";
      if (getMFObj ((*mvs)[i]) != NULL) {
	printObjet (stdout, getMFObj ((*mvs)[i]));
	cout << endl;
      }
      else {
	printExpr (getMFExpr ((*mvs)[i]));
	cout << endl;
      }
    }
  }
}
