
letter  [a-z_A-Z]
digit   [0-9]
E      [digitEdigite][+-]?{digit}+

%{
#include "../behav/Comp.h" 
#include "../behav/StateVar.h"
#include "../behav/ModeVar.h"
#include "../behav/CondVar.h"
#include "../behav/ObsVar.h"
#include "../caen/caen-algo.h"
#include <stdio.h>
#include <iostream.h>
#include <string.h>
#include <unistd.h>
#include <vector>
#include <stack>
#include <strstream>

#include "DefHybridParser.yy.cc.h"

/*#define YY_USER_INIT yyin=DefHybridParserlval.input;*/
  
  void lexError (long stade, long nligne, long nerr);
   int DefHybridParserln ();
  string type_others_def;
  extern string comp_var_name;
  extern Comp* comp;
  extern char* S1;
%}

%option yylineno
%option yywrap

%{
  extern arDef conSymb;
  extern char* nomComp;
  extern arDef symCons;  
  char *nom, *txt;
  char buf_def[100], buf_def1[100], buf_def2[16], buf_def_use[32];
  char *s_def, *s_def1, *s_def2, *s_def_use;
%}

%x STRING
%x COMMENTARY
%x STATE_VAR
%x MODE_VAR
%x OBS_VAR
%x COMMAND_VAR
%x DEPENDENT_VAR
%x MODALITIES
%x SHARED_VAL
%x SHARED_INIT
%x OTHERS_PARSE
%x DECLARATIONS
%x VAR
%START COM DEF1 DEF2 MOD INC1

%%

"/*"			{BEGIN COMMENTARY;} 
<COMMENTARY>"*/" 	{BEGIN 0;}
<COMMENTARY>"\n"
<COMMENTARY>.

\"                	{BEGIN STRING; s_def = buf_def; }
<STRING>\\n       	{ *s_def++ = '\n';}
<STRING>\\t       	{ *s_def++ = '\t';}
<STRING>\\\"      	{ *s_def++ = '\"';}
<STRING>\"        	{ *s_def++ = '\0';*s_def = 0;
                    	BEGIN 0;	
		    	DefHybridParserlval.name = buf_def;
			s_def = buf_def;
		    	return STR;
                  	}
<STRING>\n        	{ lexError(0,0,1);}
<STRING>"%"             { 
  int i=0;
  *s_def++ = *yytext;
}
<STRING>.         	{ *s_def++ = *yytext; }

"uses" {
  s_def_use = buf_def_use;
  DefHybridParserlval.declarations_def = new vector<string>();
  BEGIN DECLARATIONS;
}

<DECLARATIONS>{letter}|{digit} {*s_def_use++ = *yytext;}
<DECLARATIONS>","        {
  *s_def_use++ = '\0';
  DefHybridParserlval.declarations_def->push_back(string(buf_def_use));
  *s_def_use=0;
  s_def_use = buf_def_use;
}
<DECLARATIONS>";" {
  *s_def_use++ = '\0';
  DefHybridParserlval.declarations_def->push_back(string(buf_def_use));
  *s_def_use=0;
  s_def_use = buf_def_use;
  BEGIN 0;
  return USE;
}
<DECLARATIONS>. ;

"others: " {
  DefHybridParserlval.others_imports = new vector<pair<string, string> >();
  s_def1 = buf_def1;
  BEGIN OTHERS_PARSE;
}

<OTHERS_PARSE>{letter}|{digit} {
  *s_def1++ = *yytext;
}
<OTHERS_PARSE>" " {
  *s_def1++ = '\0';
  type_others_def = string(buf_def1);
  *s_def1=0;
   s_def1 = buf_def1;
}
<OTHERS_PARSE>(", "|",") {
  *s_def1++ = '\0';
  DefHybridParserlval.others_imports->push_back(pair<string, string>(type_others_def.c_str(), string(buf_def1)));
  *s_def1 = 0;
  s_def1 = buf_def1;
}
<OTHERS_PARSE>";" {
  *s_def1++ = '\0';
  DefHybridParserlval.others_imports->push_back(pair<string, string>(type_others_def.c_str(), string(buf_def1)));
  *s_def1 = 0;
  s_def1 = buf_def1;
  BEGIN 0;
  return IMPORT;
} 

"shared" {
  DefHybridParserlval.shared= new vector<string>();
  s_def1 = buf_def1;
  BEGIN SHARED_INIT;
}
<SHARED_INIT>"(" { 
  s_def1 = buf_def1;
  BEGIN SHARED_VAL;
} 
<SHARED_VAL>{letter}|{digit}		{*s_def1++ = *yytext;}
<SHARED_VAL>"%" {
  *s_def1++ = *yytext;
}
<SHARED_VAL>" "*","" "*			{
  *s_def1++ = '\0';
  DefHybridParserlval.shared->push_back(string(buf_def1));
  *s_def1=0;s_def1 = buf_def1;}
<SHARED_VAL>")"			{
  *s_def1++ = '\0';
  DefHybridParserlval.shared->push_back(string(buf_def1));
  *s_def1=0;
  s_def1 = buf_def1;
  BEGIN 0;
  return SHARED;
}
<SHARED_VAL>";" ;

"ModeVar"		{
  s_def = buf_def;
  s_def2 = buf_def2;
  s_def2 = "Mode";
  BEGIN MODE_VAR;
}
<MODE_VAR>";"		{
  BEGIN 0;
   *s_def++='\0';
   string var_n = comp_var_name + "." + string (buf_def);
   DefHybridParserlval.modevar = (ModeVar*) findDiscVariable (comp, var_n);
   return MODEVAR;
}	
<MODE_VAR>"("		{
   BEGIN MODALITIES;
   s_def1 = buf_def1;
}
<MODE_VAR>[^ \t]		{*s_def++ = *yytext;}

"ObsVar"		{
  s_def = buf_def;
  s_def2 = buf_def2;
  s_def2 = "Observable";
   BEGIN OBS_VAR;
}
<OBS_VAR>";"		{
   BEGIN 0;
   *s_def++='\0';
   string var_n = comp_var_name + "." + string (buf_def);
   DefHybridParserlval.obsvar = (ObsVar*) findDiscVariable (comp, var_n);
   return OBSVAR;
}	
<OBS_VAR>"("		{
   BEGIN MODALITIES;
   s_def1 = buf_def1;
}
<OBS_VAR>[^ \t]		{*s_def++ = *yytext;}

"CommandVar"		{
   s_def = buf_def;
   s_def2 = buf_def2;
   s_def2 = "Command";
   BEGIN COMMAND_VAR;
}
<COMMAND_VAR>";"		{
   BEGIN 0;
   *s_def++='\0';
   string var_n = comp_var_name + "." + string (buf_def);
   DefHybridParserlval.cmdvar = (CommandVar*) findDiscVariable (comp, var_n);
   return COMMANDVAR;
}	
<COMMAND_VAR>"("		{
   BEGIN MODALITIES;
   s_def1 = buf_def1;
}
<COMMAND_VAR>[^ \t]		{*s_def++ = *yytext;}

"DependentVar"		{
   s_def = buf_def;
   s_def2 = buf_def2;
   s_def2 = "Dependent";
   BEGIN DEPENDENT_VAR;
}
<DEPENDENT_VAR>";"		{
   BEGIN 0;
   *s_def++='\0';
   string var_n = comp_var_name + "." + string (buf_def);
   DefHybridParserlval.depvar = (DependentVar*) findDiscVariable (comp, var_n);
   return DEPENDENTVAR;
}	
<DEPENDENT_VAR>"("		{
   BEGIN MODALITIES;
   s_def1 = buf_def1;
}
<DEPENDENT_VAR>[^ \t]	{*s_def++ = *yytext;}

<MODALITIES>{letter}|{digit}|("+"|"-")		{*s_def1++ = *yytext;}
<MODALITIES>[ \t] ;
<MODALITIES>","			{*s_def1++ = '\0';
   /*values_def.push_back(string(buf_def1));*/*s_def1=0;s_def1 = buf_def1;}
<MODALITIES>")"			{*s_def1++ = '\0';
 /*values_def.push_back(string(buf_def1));*/*s_def1=0;s_def1 = buf_def1;
   if (strcmp(s_def2, "Mode") == 0) BEGIN MODE_VAR;
   else if (strcmp(s_def2, "Command") == 0) BEGIN COMMAND_VAR;
   else if (strcmp(s_def2, "Dependent") == 0) BEGIN DEPENDENT_VAR;
   else if (strcmp(s_def2, "Observable") == 0) BEGIN OBS_VAR;
}

[ \t]                 ;
"=>"         		{return IMP;}
"|"			{return OR;}
"&"			{return AND;}
"cin"                   {return CIN;}
"cout"                  {return COUT;}
"="                     {DefHybridParserlval.OpRel=EQ; return OPREL;}
"!="                    {DefHybridParserlval.OpRel=NE; return OPREL;}
"\<="                   {DefHybridParserlval.OpRel=LE; return OPREL;}
"\<"                    {DefHybridParserlval.OpRel=LT; return OPREL;}
"\>="                   {DefHybridParserlval.OpRel=GE; return OPREL;}
"\>"                    {DefHybridParserlval.OpRel=GT; return OPREL;}
"+oo"                   {return PLUSINF;}
"-oo"                   {return MOINSINF;}
"\*\*"|"\^"             {return EXPO;}
"boolean"|"BOOLEAN"     {return BOOL;}
"CondVar"               {return CONDVAR;}
"condition"|"CONDITION" {return COND;}
"delay"|"DELAY"         {DefHybridParserlval.CoefType=DELAY; return COEFTYPE;}
"display"|"DISPLAY"     {DefHybridParserlval.InterType=DISPLAY; return INTERFACE;}
"false"|"FALSE"         {DefHybridParserlval.String = mkString (DefHybridParsertext);
                         return BOOLEEN;}
"exo"                   {return EXO;}
"gain"|"GAIN"           {DefHybridParserlval.CoefType=GAIN; return COEFTYPE;}
"xi"|"XI"               {DefHybridParserlval.CoefType=XI; return COEFTYPE;}
"w"|"W"                 {DefHybridParserlval.CoefType=PULSE; return COEFTYPE;}
"n1"|"N1"               {DefHybridParserlval.CoefType=N1; return COEFTYPE;}
"n2"|"N2"               {DefHybridParserlval.CoefType=N2; return COEFTYPE;}
"a0"|"A0"               {DefHybridParserlval.CoefType=A0; return COEFTYPE;}
"a1"|"A1"               {DefHybridParserlval.CoefType=A1; return COEFTYPE;}
"a2"|"A2"               {DefHybridParserlval.CoefType=A2; return COEFTYPE;}
"-D->"                  {DefHybridParserlval.InfluType=DINFL; return INFLUES;}
"-D2->"                 {DefHybridParserlval.InfluType=D2INFL; return INFLUES;}
"-I->"                  {DefHybridParserlval.InfluType=IINFL; return INFLUES;}
"-S->"                  {DefHybridParserlval.InfluType=SINFL; return INFLUES;}
"-C->"                  {DefHybridParserlval.InfluType=CINFL; return INFLUES;}
"c+"                    {return CPLUS;}
"c-"                    {return CMIN;}
"in"|"IN"               {DefHybridParserlval.OpRel=(opRel)IN; return OPREL;}
"init"|"INIT"           {return INIT;}
"input"|"INPUT"         {DefHybridParserlval.InterType=INPUT; return INTERFACE;}
"instance"|"INSTANCE"   {return INSTANCE;}
"measure"|"MEASURE"     {DefHybridParserlval.InterType=MEASURE; return INTERFACE;}
"parameter"|"PARAMETER" {return PARAMETER;}
"resptime"|"RESPTIME"   {DefHybridParserlval.CoefType=RESPTIME; return COEFTYPE;}
"true|TRUE"             {DefHybridParserlval.String = mkString (DefHybridParsertext);
                               return BOOLEEN;}
"variable"|"VARIABLE"   {return VARIABLEDEF;}

"mapfunc" | "MAPFUNC"   {return MAPFUNC;}
"constraints"           {return CONSTRAINTS;}
"transitions"           {return TRANSITIONS;}
"vardef"                {return VARDEF;}
"Component"	 	{return COMPONENT;}
"Next"			{return NEXT;}
"Nominal"               {return NOMINAL;}
"Idle"                  {return IDLE;}
"Fail"                  {return FAIL;}
"VarAssign"             {return VARASSIGN;}

[a-zA-Z][._0-9a-zA-Z]* {
  nom = buf_def;
  string co_n;
  char*  tok;
  char buftok[32];
  tok = buftok;
  tok = strtok (mkString (DefHybridParsertext), ".");
  if ((strtok (NULL, ".") == NULL)
      && (strcmp (DefHybridParsertext, "FALSE"))
      && (strcmp (DefHybridParsertext, "false"))
      && (strcmp (DefHybridParsertext, "TRUE"))
      && (strcmp (DefHybridParsertext, "true"))) {
    if (! strcmp (DefHybridParsertext, "cmdin")) {
      strcpy (nom, (*comp->cmd_in)[0]->name.c_str());
    }
    else {
      strcpy (nom, comp_var_name.c_str ());
      strcat (nom, ".");
      strcat (nom, DefHybridParsertext);
    }
  }
  else if ((strcmp (DefHybridParsertext, "FALSE"))
	   && (strcmp (DefHybridParsertext, "false"))
	   && (strcmp (DefHybridParsertext, "TRUE"))
	   && (strcmp (DefHybridParsertext, "true"))) {
     if ((co_n = comp->findCorresName (string (tok))) == "")
       semError (0, DefHybridParserln (), 73, tok);
     strcpy (nom, co_n.c_str());
     strcat (nom, ".");
     free (tok);
     char tok2[32];
     /*tok = mkString (DefHybridParsertext);*/
     strcpy (tok2, DefHybridParsertext);
     strcat (tok2, ".");
     strtok (tok2, ".");
     strcat (nom, strtok (NULL, "."));
  }
   conSymb = searchDef (&symCons, nom);
  if (isNull (conSymb)) {
    DefHybridParserlval.var = mkString (nom);
    return VARIABLE;
  }
  else {
    DefHybridParserlval.var = txt = getArDefTxt (conSymb);
    if ((! strcmp (txt, "FALSE"))
	|| (! strcmp (txt, "false"))
	|| (! strcmp (txt, "TRUE"))
	|| (! strcmp (txt, "true")))
    {return BOOLEEN;}
    else if (isalpha (txt[0]))
       {return VARIABLE;}
    else
    {return REEL;}
  }
}
{digit}+                |
{digit}+"."{digit}*({E})?   |
{digit}*"."{digit}+({E})?   |
{digit}+{E}             {DefHybridParserlval.String = mkString (DefHybridParsertext); return REEL;}
"\n"                    ;
.            		{return DefHybridParsertext[0];}

%%

void lexError (long stade, long nligne, long nerr) {
  fprintf (stderr, "lexError\n");
}

int DefHybridParserwrap(void) {
  DefHybridParserlineno = 1;
  return 1;
}

int DefHybridParserln() {
  return DefHybridParserlineno;
}
