 
%{
#include "../itms/itms.h"
#include "../behav/Comp.h" 
#include "../behav/StateVar.h"
#include "../behav/ModeVar.h"
#include "../behav/CondVar.h"
#include "../behav/ObsVar.h"
#include "../caen/caen-algo.h"
#include <stdio.h>
#include <string.h>
#include <unistd.h>
#include <vector>

#ifndef EQBOOL
#define EQBOOL
struct eqbool
  {
    bool operator()(bool s1, bool s2)
    {
      return (s1 == s2);
    }
};
#endif

 void parseHybridDefFile(const char* deffilename, vector<string>* ar, Comp* co);
 int parseContFile(const char* deffilename);
 extern int DefHybridParserlex();
 extern int DefHybridParserln();
 StateFormula* findStf (Atom* at, string op, StateFormula* stf1, StateFormula* stf2);
 cond findCond (enum boolVal b);
 cond findCond (variable v, enum opRel op, domain d, StateFormula* a);
 cond findCond (Atom* at);
 cond findCondExpr (bool bd, expr e1, enum opRel op, expr e2);
 cond findCond (cond c1, enum condType ct, cond c2);
 expr findExpr (expr e1, char c, expr e2);
 expr findExpr (long s, expr e1);
 expr findExpr (variable v);
 bool isEqCond (expr e, cond c);
 bool isEqCond (variable v, enum opRel op, domain d, StateFormula* a, cond c, Atom* at);
 cond mkCondStf (StateFormula* stf);
 cond mkCondAt (Atom* at, bool b, Comp* co);
 extern void setConditionName (cond cd, Comp* co);
 extern long eqObj (objet a, objet b);
 int DefHybridParserrestart(FILE* fi);
 void DefHybridParsererror(const char* s);
 Atom* getAtomFromPair(string s, vector<pair<string, Atom*> >* vec);
 void transToDot(Transition* tr);
 void toDotDef();
 void flushS ();
 void prodError (const char *s, const char *t);

 /* from caen. */
 variable cVar;
 gVar Gv2;
 listcaenGVar Lg2;
 FILE* dotfile;
 char fileInDef[40];
 char dot_buf_def_cont[100000];
 char* dot_char;
 void createModeStf();
 void setInfluSymbNameList (listcaenInfl lf, char* na);
 void infToDotList(listcaenInfl lf);
 void infToDot(influence ifl);
 void toDotDefcont();
 /* end from caen. */
 
 extern long guards_int;      /* transitions guards on interval non-measured interval value*/
 extern int koa_hybrid;      /* hybrid mode flag */
 extern itms* reasoner;
 extern long loadError;
 extern string defname;
 extern string comp_var_name;
 extern FILE* DefHybridParserin;
 extern char bufErr[100];
 extern long recover;
 extern char* nomComp;
 extern arDef conSymb;
 extern char* S1;
 extern listcaenInfl Lif1;
 extern domain Dom1;
 extern objet Obj1;
 extern valeur Vl1;
 extern range Rn1;
 extern listcaenParEff Le1;
 extern paramEff Pe1;
 extern listcaenCoef Lc1;
 extern boolVal bval;
 extern cond Cn1;
 extern expr Ex1;
 extern gVar Gv1;
 extern listcaenGVar Lg1;
 extern listcaenInitVar Liv1;
 extern listcaenParFor Lf1;
 extern listcaenLong Ll1;
 extern listcaenExpr Lex1;
 extern paramFor Pf1;
 extern listcaenExpr globCListcaen;
 extern listcaenExpr condCListcaen;
 listcaenExpr mfCListcaen;
 char* full_path_filename_def;
 const char* declaration_filename;
 string dot_buf_def;   /* buffer for dot file generation. */
 extern vector<pair<string, StateVar*> >* variables_disc;
 extern vector<component>* comps;
 extern FILE* def_file;
 extern vector<string>* declarations;
 Comp* comp;
 Atom* at;
 StateVar* sta;
 extern vector<cond>* conditions;
 extern vector<StateFormula*>* stfs;
 vector<MapFunc*>* mvfs;
 vector<mapfVar>* mvs;
 bool hybrid;
 int glob;
 extern listcaenExpr var_expr;
 cond expr_cond;
 int numCstrsCond;
 int numCstrsGlob;
 int diffCstrsCond;
 int numMFC;
 vector<string>* args;
 const char* filename;
 cond modes_cond;       /* cond for all-modes influences */
%}

%union {
  long Long;
  enum objType ObjType;
  double Double;
  enum boolVal BoolVal;
  char *String;
  enum opRel OpRel;
  objet Objet;
  struct {
    objet Obj;
    char *Txt;
  } ObjAndString;
  variable Variable;
  listcaenVar ListcaenVar;
  domain Domain;
  enum interType InterType;
  enum coefType CoefType;
  coef Coef;
  listcaenCoef ListcaenCoef;
  cond Cond;
  enum influType InfluType;
  influence Influence;
  listcaenInfl ListcaenInfl;
  initVar InitVar;
  listcaenInitVar ListcaenInitVar;
  paramFor ParamFor;
  listcaenParFor ListcaenParFor;
  paramEff ParamEff;
  listcaenParEff ListcaenParEff;
  expr Expr;
  char* name;
  FILE* input;
  FILE* decl_input;
  vector<string>* declarations_def; /**< store model files headers. */
  vector<pair<string, string> >* others_imports; /**< store components in'others' imports. */
  vector<string>* shared; /**< store exogeneous shared variables. */
  ModeVar* modevar;
  ObsVar* obsvar;
  CommandVar* cmdvar;
  DependentVar* depvar;
  CondVar* condvar;
  char* var;
  char* varchar;
  Atom* tom;
  StateFormula* stateform;
  Formula* formul;
  Transition* trans;
  vector<MapFunc*>* mfs;
  MapFunc* mf;
  vector<mapfVar>* mvfl;
  mapfVar mv;
  listcaenExpr ListcaenExpr;
  double* tcoeffs; /* transitions probability and cost */
}

%{
		
#define Wrong1 "statement"
#define Wrong2 "declaration_cont"
#define Wrong3 "var_decl_list"
#define Wrong4 "var_decl"
#define Wrong5 "domain"
#define Wrong6 "signed_real"
#define Wrong8 "param_eff_list"
#define Wrong9 "rule"
#define Wrong10 "influence"
#define Wrong11 "coeff_list"
#define Wrong12 "coeff"
#define Wrong13 "bool_cond"
#define Wrong14 "rule_list"
#define Wrong15 "equation"
#define Wrong16 "expression"
#define Wrong17 "initialization"
#define Wrong18 "init_var_list"
#define Wrong19 "init_var"

#define Expect0 ""
#define Expect1 "VARIABLE"
#define Expect2 ","
#define Expect3 "[ VARIABLE REEL + -"
#define Expect4 "]"
#define Expect5 "+oo REEL + -"
#define Expect6 "-oo REEL + -"
#define Expect7 "REEL"
#define Expect8 "("
#define Expect9 "BOOLEEN VARIABLE REEL"
#define Expect10 ", )"
#define Expect11 "VARIABLE REEL + -"
#define Expect12 "& | )"
#define Expect13 "( BOOLEEN VARIABLE !"
#define Expect14 "COEFTYPE"
#define Expect15 "OPREL"
#define Expect16 "CONDITION } VARIABLE REEL + -"
#define Expect17 ";"
#define Expect18 "CONDITION VARIABLE REEL + -"
#define Expect19 "{"
#define Expect20 "OPREL + - * / **"
#define Expect21 "( VARIABLE BOOLEEN REEL + -"
#define Expect22 "BOOL PARAMETER VARIABLEDEF"
#define Expect23 ", )"
#define Expect24 "CONDITION } VARIABLE INSTANCE REEL + -"

%}

%token INTEGER
%token STATEFORMULA
%token <name> STR
%token IMP
%token NEXT COMPONENT RE OR AND COMMENTARIES CMIN CPLUS VARASSIGN
%token <declarations_def> USE
%token TRANSITIONS CONSTRAINTS VARDEF NOMINAL IDLE FAIL CIN COUT OTHERS
%token <shared> SHARED
%token <others_imports> IMPORT
%token <var> VARIABLE
%token <var> NVARIABLE
%token <modevar> MODEVAR
%token <obsvar> OBSVAR
%token <cmdvar> COMMANDVAR
%token <depvar> DEPENDENTVAR
%token CONDVAR

%token BOOL COND EXPO EXO INIT INSTANCE MOINSINF PARAMETER PLUSINF VARIABLEDEF ';' ',' '(' ')' '[' ']' ':' '{' '}'
 
%token <String> BOOLEEN
%token <CoefType> COEFTYPE
%token <InfluType> INFLUES
%token <InterType> INTERFACE
%token <String> REEL
%token <OpRel> OPREL

%type <Long> signe
%type <Double> signed_real
%type <Double> borne_inf
%type <Double> borne_sup
%type <ObjAndString> constante
%type <Variable> variable_cont
%type <Variable> var_decl
%type <ListcaenVar> variable_list
%type <ListcaenVar> var_decl_list
%type <Domain> domain
%type <Coef> coeff
%type <ListcaenCoef> coeff_list
%type <Influence> influence
%type <Influence> rule
%type <ListcaenInfl> rule_list
%type <Cond> bool_cond
%type <InitVar> init_var
%type <ListcaenInitVar> init_var_list
%type <ParamFor> param_for
%type <ListcaenParFor> param_for_list
%type <ParamEff> param_eff
%type <ListcaenParEff> param_eff_list
%type <Expr> expression
%type <condvar> conds_decl
%type <tom> atom
%type <stateform> stateformula
%type <formul> formula
%type <trans> transition
%type <mfs> mapping_func_list
%type <mf> mapping_func
%type <mvfl> mapping_var_list
%type <mv> mapping_var
%type <tcoeffs> transition_coeffs

%left  OR   /* beware when parsing logical constraints !!! */
%left  AND  /* idem !!! */
%right '!'
%left '+' '-'
%left '*' '/'
%left EXPO

%start program

%%

program: 	declaration program {}      
| caenprogram
| {}		       
;				

declaration:	use_decl component_decl ';' '{' constructor_decl '}' VARDEF '{' vars_decl '}' CONSTRAINTS '{' forms_decl '}' rules TRANSITIONS '{' transition '}'	{reasoner->addComp (comp);}
| use_decl component_decl ';' '{' constructor_decl '}' VARDEF '{' vars_decl '}' CONSTRAINTS '{' rules '}' TRANSITIONS '{' transition '}'	{reasoner->addComp (comp);}
| use_decl component_decl '{' constructor_decl '}' VARDEF '{' vars_decl '}' CONSTRAINTS '{' forms_decl '}' rules TRANSITIONS '{' transition '}'	{reasoner->addComp (comp);}
| use_decl component_decl '{' constructor_decl '}' VARDEF '{' vars_decl '}' CONSTRAINTS '{' rules '}' TRANSITIONS '{' transition '}'	{reasoner->addComp (comp);}
;

use_decl:  USE {
   string defname;
   bool found;
   for (unsigned int i=0; i<$1->size(); i++) {
      found = 0;
      /*cout << "use: " << (*$1)[i] << endl;*/
      for (unsigned int j=0; j<comps->size (); j++) {
      if (getComponentType ((*comps)[j]) == (*$1)[i])
	   found = 1;
      }
      if (!found)
	semError (0, DefHybridParserln (), 80, (*$1)[i].c_str ());
   }
   delete $1;
   numInflu = 0;
   numCond = comp->numCond;
}
| {
  numInflu = 0;
  numCond = comp->numCond;
}
;

caenprogram : statement
            | caenprogram statement
            | statemente
            | caenprogram statemente
{prodError (Wrong1, Expect0);                       /* syn1.ce */
 flushS ();}
;

statement : declaration_cont ';'
  | VARIABLE ':' rule ';'
{
 if (isInInfluListcaen ($1, comp->influListcaen))
   semError (0, DefHybridParserln(), 48, filename);  /* component name or rule name already defined.  */
 else { 
   setInfluNom ($3, $1);
   /*infToDot($3);*/
   comp->influListcaen = catListcaenInfl (comp->influListcaen, mkListcaenInfl ($3));}}
          | VARIABLE ':' '{' rule_list ';' '}'
{if (! isNull (nomComp) && isNull (conSymb))        /* local VARIABLE in an instance */
  semError (0, DefHybridParserln(), 49, filename);         /* block of rules not allowed inside a model. */
 if (isInInfluListcaen ($1, comp->influListcaen))
   semError (0, DefHybridParserln(), 48, filename);  /* component name or rule name already defined.  */
 else { 
   setRulesNames ($4, $1);
   /*infToDotList($4);*/
   comp->influListcaen = catListcaenInfl (comp->influListcaen, $4);}}
| VARIABLE ':' stateformula '{' rule_list ';' '}' {
  cout << "adding nothing\n";
}
| equation ';'
| INIT init_var_list ';'
{comp->initListcaen = catListcaenInitVar (comp->initListcaen, $2);
toDotDef();}
;

statemente: declaratione_cont
          | VARIABLE ':' rulee {}
          | VARIABLE ':' '{' rule_liste ';' '}' {}
          | VARIABLE ':' '{' rule_list ';' error {}
{prodError (Wrong1, Expect16);}                       /* syn34.ce */
          | VARIABLE ':' '{' rule_list error '}'
{prodError (Wrong1, Expect17);}                       /* syn35.ce, syn36.ce */
          | VARIABLE ':' '{' error '}'
{prodError (Wrong1, Expect18);}                       /* syn37.ce */
          | VARIABLE ':' COND '(' bool_cond ')' '{' rule_liste ';' '}' {}
          | VARIABLE ':' COND '(' bool_conde ')' '{' rule_list ';' '}' {}
          | VARIABLE ':' COND '(' bool_cond ')' '{' rule_list ';' error
{prodError (Wrong1, Expect16);}                         /* syn55.ce */
          | VARIABLE ':' COND '(' bool_cond ')' '{' rule_list error '}'
{prodError (Wrong1, Expect17);}                         /* syn56.ce, syn57.ce */
          | VARIABLE ':' COND '(' bool_cond ')' '{' error '}'
{prodError (Wrong1, Expect18);}                         /* syn58.ce */
          | equatione
{prodError (Wrong1, Expect0);}
          | INIT init_var_liste
          | INIT error ';'
{prodError (Wrong17, Expect1);}                       /* syn45.ce */
;

component_decl:  	COMPONENT STR       {
	    /*atoms = new multimap<bool, Atom*, eqbool>();
	      others_atoms = new vector<pair<string, Atom*> >();*/
	    mvs = new vector<mapfVar> ();
	    mvfs = new vector<MapFunc*> ();
	    glob = 0;
	    numCstrsCond = diffCstrsCond = numCstrsGlob = numMFC = 0;
	    hybrid = 0;
	    modes_cond = 0;
	    mfCListcaen = NULL;
}
;

constructor_decl: CIN ':' commands_decl constructor_decl {}
| CIN EXO ':' commands_decl constructor_decl {}
| CIN ':' SHARED CMIN ';' constructor_decl {
   CommandVar* cmd;
   string cmd_in_name;
   int dot_pos;
   Comp* com_co;
   comp->cmd_in = new vector<CommandVar*> ();

   if ((*args)[0] != "0") {
      comp->str_in = $3;
      dot_pos = (*args)[0].find (".");
      cmd_in_name = (*args)[0].substr(0, dot_pos);
      com_co = findComp (cmd_in_name);
      if ((cmd = (CommandVar*) findDiscVariable (com_co, (*args)[0])) == NULL)
	semError (0, DefHybridParserln (), 73, (*args)[0].c_str ());
      else {
	comp->cmd_in->push_back (cmd);
	if (comp->corres_import_comps == NULL)
	  comp->corres_import_comps = new vector<pair<string, string> >(); /* automatically created reference for cmd_in variable.*/
	comp->share_commanded = true;
	comp->corres_import_comps->push_back (pair<string, string> ("cmpin", com_co->getVarName ()));
      }   
   }
   else semError (0, DefHybridParserln (), 76, filename);
}
| CIN ':' SHARED CPLUS ';' constructor_decl {
   delete $3;
}
| COUT ':' commands_decl constructor_decl {}
| CIN ':' constructor_decl
| COUT ':' constructor_decl
| IMPORT {
  if ($1->size () != args->size ()-2)
    semError (0, DefHybridParserln (), 69, filename);
  string atom_store; /* name for storage */
  string atom_name; /* name of the created atom */
  Comp* com;
  string comp_arg_name;
  string comp_name;
  if (comp->corres_import_comps == NULL)
    comp->corres_import_comps = new vector<pair<string, string> >();
  if (comp->imported_comps == NULL)
    comp->imported_comps = new vector<Comp*> ();

  for (unsigned int ii=0; ii<$1->size(); ii++) {
    /*cout << (*$1)[ii].first << endl;*/ /* type */
    /*cout << (*$1)[ii].second << endl;*/ /* var name in file */

    if ((com = findComp ((*args)[ii+2])) != NULL) {
      if ((*$1)[ii].first == com->type)
	comp->corres_import_comps->push_back (pair<string, string>((*$1)[ii].second, com->getVarName ()));
      else semError (0, DefHybridParserln (), 70, filename);            /* error on component type. */
      comp->imported_comps->push_back (com);
    } 
    else semError (0, DefHybridParserln (), 67, (*args)[ii+2].c_str());          /* component not declared */
  }
  delete $1;
}
|
;

commands_decl: COMMANDVAR {}

vars_decl:	MODEVAR vars_decl {}
| OBSVAR vars_decl {}
| DEPENDENTVAR vars_decl {}
| conds_decl vars_decl {}
| declaration_cont ';' vars_decl
| declaratione_cont vars_decl
| {glob = 1;} /* global constraints flag (conditions finished) */
;

conds_decl: CONDVAR VARIABLE '(' bool_cond_list ')' ';' {
  $$ = (CondVar*) findDiscVariable (comp, string ($2));}
;

forms_decl: formula ';' forms_decl {
  comp->addFormulaToCS ($1);
}
| formula ';' {
  comp->addFormulaToCS ($1);
}
| formula {}
;

rules :          VARIABLE ':' rule ';' rules {
 if (isInInfluListcaen ($1, comp->influListcaen))
   semError (0, DefHybridParserln(), 48, filename);  /* component name or rule name already defined.  */
 else { 
   string symbn = string ($1);
   setInfluNom ($3, $1);
   setInfluSymbName ($3, mkString (symbn.substr (symbn.find (".")+1, symbn.size ()).c_str()));
   if (getInfluCond ($3) == NULL) {
     if (modes_cond == NULL)
       createModeStf ();
     setInfluCond ($3, modes_cond);         /* set standard conditions (all modes except unknown) */
   }
   /*infToDot($3);*/
   comp->influListcaen = catListcaenInfl (comp->influListcaen, mkListcaenInfl ($3));}glob = 2;}
          | VARIABLE ':' '{' rule_list ';' '}' rules
{if (! isNull (nomComp) && isNull (conSymb))        /* local VARIABLE in an instance */
  semError (0, DefHybridParserln(), 49, filename);         /* block of rules not allowed inside a model. */
 if (isInInfluListcaen ($1, comp->influListcaen))
   semError (0, DefHybridParserln(), 48, filename);  /* component name or rule name already defined.  */
 else { 
   setRulesNames ($4, $1);
   string symbn = string ($1);
   setInfluSymbNameList ($4, mkString (symbn.substr (symbn.find (".")+1, symbn.size ()).c_str ()));
   /*infToDotList($4);*/
   /*andRulesConds ($4, modes_cond, comp);*/   /* set standard conditions (all modes except unknown) */
   comp->influListcaen = catListcaenInfl (comp->influListcaen, $4);}glob = 2;}
          | VARIABLE ':' stateformula '{' rule_list ';' '}' rules
{if (! isNull (nomComp) && isNull (conSymb))        /* local VARIABLE in an instance */
  semError (0, DefHybridParserln(), 49, filename);         /* block of rules not allowed inside a model. */
 if (isInInfluListcaen ($1, comp->influListcaen))
   semError (0, DefHybridParserln(), 48, filename);  /* component name or rule name already defined.  */
 else {
   setRulesNames ($5, $1);
   string symbn = string ($1);
   setInfluSymbNameList ($5, mkString (symbn.substr(symbn.find (".")+1, symbn.size ()).c_str ()));
   /*infToDotList($5);*/
   andRulesConds ($5, mkCondStf ($3), comp);  /* and ? */
   comp->influListcaen = catListcaenInfl (comp->influListcaen, $5);}glob = 2;}
          | equation ';' rules
{ cout << "equation detected\n"; }
          | INIT init_var_list ';' rules
{comp->initListcaen = catListcaenInitVar (comp->initListcaen, $2);
 /*toDotDefcont();*/glob = 2;}
| {glob = 2;}
;

transition:	VARIABLE ':' '{' NOMINAL stateformula next_statement transition_coeffs ';' mapping_func_list '}' transition { 
 /* TODO */
}
| VARIABLE ':' '{' NOMINAL stateformula NEXT stateformula transition_coeffs ';' mapping_func_list '}' transition {
  $$ = new Transition ($5, $7, "Nominal", $8[0], $8[1], 0);
  if (! isNull ($10))
    $$->mf = $10;
  else $$->mf = NULL;
  comp->addTransitionToC ($$);
  free ($1);
  free ($8);
}
| IDLE stateformula NEXT stateformula REEL ';' transition {  /* idle transition have no cost */
  $$ = new Transition ($2, $4, "Nominal", strtod ($5, NULL), 0, 1);
  $$->mf = NULL;
  comp->addTransitionToC ($$);
}
| VARIABLE ':' '{' FAIL stateformula NEXT stateformula REEL ';' mapping_func_list '}' transition {
  $$ = new Transition ($5, $7, "Fail", strtod ($8, NULL), 0, 0);
  if (! isNull ($10))
    $$->mf = $10;
  else $$->mf = NULL;
  comp->addTransitionToC ($$);
  free ($1);
  free ($8);
}
| {}
;

next_statement: NEXT stateformula next_statement {
 /* TODO */
}
| NEXT stateformula ';' {
  /* TODO */
}
;

transition_coeffs: REEL REEL {
  $$ = (double*) malloc (2*sizeof (double));
  $$[0] = strtod ($1, NULL);
  $$[1] = strtod ($2, NULL);
}
| REEL { /* cost can be omitted but not the probability (TODO: issue a warning anyway) */
  $$ = (double*) malloc (2*sizeof (double));
  $$[0] = strtod ($1, NULL);
  $$[1] = 0;
}  
;

mapping_func_list : mapping_func ';'{
  if (! isNull ($1)) {
    $$ = new vector<MapFunc*> ();
    $$->push_back ($1);
  }
  else $$ = NULL;
}
| mapping_func_list mapping_func ';' {
    $$->push_back ($2);
}
| {$$ = NULL;}
;

mapping_var_list : mapping_var {
  if (isNull ($1))
    semError (0, DefHybridParserln(), 19, filename);
  mvs->push_back($1);
  $$ = mvs;
}
| mapping_var_list ',' mapping_var {
  if (isNull ($3))
    semError (0, DefHybridParserln(), 19, filename);
  mvs->push_back ($3);
  $$ = mvs;
}
| {}
;

mapping_func : stateformula ':' mapping_var_list {
  cond atco;
  if (isNull (atco = findCond (0, EQ, 0, $1)))
    atco = mkCondStf ($1);
  $$ = new MapFunc (atco, $3);
  mvs->clear ();
}
| mapping_var_list {
  $$ = new MapFunc ($1);
  /*for (unsigned int i=0; i<$1->size(); i++)
    printMFVar (stdout, (*$1)[i]);*/
  mvs->clear ();
}
| {
  /*if (hybrid) {
    semError (2, DefHybridParserln(), 65, filename); */      /* assume id mapping function. */
    /*$$ = NULL;
  }
  else {*/
    $$ = NULL;
  /*}*/
}
;

mapping_var : variable_cont OPREL expression {
  if (isVarNew ($1)) {
    semError (0, DefHybridParserln(), 19, filename);      /* "undefined variable in initialization." */
    $$ = NULL;}
  else if (! isNull ($3)) {
    $$ = buildMapfVarExpr ($1, $3);
  }
}
/*| variable_cont OPREL domain {
  if (isVarNew ($1)) {
    semError (0, DefHybridParserln(), 19, filename);          
    $$ = NULL;}
  else if (! isNull ($3)) {
    $$ = buildMapfVar ($1, $3);
  }
}*/
;

formula : stateformula IMP stateformula {
   $$ = new Formula ($1, $3, NULL);
}
| stateformula IMP VARASSIGN VARIABLE OPREL VARIABLE {
   /* TODO */
}
| '(' formula ')' AND formula {
   if (($2->getOperat () == $5->getOperat ()) && ($2->getOperat () == "and")) {
      $2->addFormula ($5);
      $$ = $2;
   }
   else {
      $$ = new Formula ();
      $$->setOperat ("and");
      $$->addFormula ($2);
      $$->addFormula ($5);
   }
}
| '(' formula ')' OR formula {
   if (($2->getOperat () == $5->getOperat ()) && ($2->getOperat () == "or")) {
      $2->addFormula ($5);
      $$ = $2;
   }
   else {
      $$ = new Formula ();
      $$->setOperat ("or");
      $$->addFormula ($2);
      $$->addFormula ($5);
   }
}
| '(' formula ')' {
   $$ = $2;
}
;

stateformula: 	'(' atom ')'   {
  $$ = new StateFormula ($2, $2->neg);
  stfs->push_back ($$);
}
| COND bool_cond {
  Atom* atco;
  if (isNull (atco = getCondAtom ($2)))
    semError (0, DefHybridParserln(), 64, filename);
  else {
    $$ = new StateFormula (atco);
    stfs->push_back ($$);
  }
}
| stateformula AND stateformula {
  Atom* at;
  if ((($1->getOperat () == $3->getOperat ())
      && ($1->getOperat () == "and"))
      || ($1->getOperat () == ""
	  && $3->getOperat () == "and")
      || ($3->getOperat () == ""
	  && $1->getOperat () == "and")
      || ($1->getOperat () == ""
	  && $3->getOperat () == "")) {
    if ($3->atoms->size () == 1) {
      at = (*$3->atoms->begin ()).second;
      $1->addAtom (at, at->neg);
      $1->setOperat ("and");
      $$ = $1;
    }
    else if ($1->atoms->size () == 1) {
      at = (*$1->atoms->begin ()).second;
      $3->addAtom (at, at->neg);
      $3->setOperat ("and");
      $$ = $3;
    }
    else {
      $1->addStateFormula ($3);
      $$ = $1;
    }
  }
  else {
    $$ = new StateFormula ();
    $$->setOperat ("and");
    $$->addStateFormula ($1);
    $$->addStateFormula ($3);
    stfs->push_back ($$);
  }
}
| stateformula OR stateformula {
  if ((($1->getOperat () == $3->getOperat ()) 
       && ($1->getOperat () == "or"))
      || ($1->getOperat () == ""
	  && $3->getOperat () == "or")
      || ($3->getOperat () == ""
	  && $1->getOperat () == "or")
      || ($1->getOperat () == ""
	  && $3->getOperat () == "")) {
    if ($3->atoms->size () == 1) {
      at = (*$3->atoms->begin ()).second;
      $1->addAtom (at, at ->neg);
      $1->setOperat ("or");
      $$ = $1;
    }
    else if ($1->atoms->size () == 1) {
      at = (*$1->atoms->begin ()).second;
      $3->addAtom (at, at ->neg);
      $3->setOperat ("or");
      $$ = $3;
    }
    else {
      $1->addStateFormula ($3);
      $$ = $1;
    }
  }
  else {
    $$ = new StateFormula ();
    $$->setOperat ("or");
    $$->addStateFormula ($1);
    $$->addStateFormula ($3);
    stfs->push_back ($$);
  }
}
| '(' stateformula ')' {
  $$ = $2;
}
;

atom:		VARIABLE OPREL STR       {
  int perc = 0;
  string var1 = string ($1);
  string val1 = string ($3);
  if (EQ == $2) {
    string other_name = var1 + "=" + val1;
    if ((sta = comp->getStateVariable(var1)) != NULL) { 
      for (unsigned int i=0; i<sta->atoms_links->size(); i++) {
	if ((*sta->atoms_links)[i]->value == val1) {
	  at = (*sta->atoms_links)[i];
	  if (at == NULL)
	    semError (0, DefHybridParserln(), 74, other_name.c_str ());
	}
      }
      at->neg = 1;
    }
    else if ((at = findAtom (other_name, comp)) != NULL)  /* idem for atoms from others def files. */
      at->neg = 1;
    else if (val1[0] == '%' || (perc = val1.find ("%")) == -1) {
      string dn;
      if (val1[0] == '%') {
	perc = 0;
	dn = comp->name 
	+ "_" + val1.substr (perc+1, val1.length ());
      }
      else dn = val1.substr (0, perc) + "_" + comp->name 
	+ "_" + val1.substr (perc+1, val1.length ());
      other_name = var1 + "=" + dn;
      if ((at = findAtom (other_name, comp)) != NULL) {
	if (isNull (at->dyn_name))
	  at->dyn_name = new hash_map<const char*, string, hash<const char*>, eqstr> ();
	at->neg = 1;
	(*at->dyn_name)[comp->getName ()] = val1;
      }
      else semError (0, DefHybridParserln(), 74, string("NULL atom: " + other_name).c_str ());
    }
    else if (at == NULL)
      semError (0, DefHybridParserln(), 74, string("NULL atom: " + other_name).c_str ());
    else {
      semError (0, DefHybridParserln(), 73, $1);
    }
  }
  else if ($2 == NE) {
    string other_name = var1 + "=" + val1;
    /* create a new atom - searching for an existing state variable */
    if ((sta =  comp->getStateVariable(var1)) != NULL) {
	for (unsigned int i=0; i<sta->atoms_links->size(); i++) {
	  if ((*sta->atoms_links)[i]->value == val1) {
	    at = (*sta->atoms_links)[i];
	    if (at == NULL)
	      semError (0, DefHybridParserln(), 74, other_name.c_str ());
	  }
	}
	at->neg = 0;
	/*atoms->insert(pair<bool, Atom*>(0, at));*/
      }
    /* idem for atoms from others def files. */
    else if ((at = findAtom (other_name, comp)) != NULL)
      at->neg = 0;
    else if (val1[0] == '%' || (perc = val1.find ("%")) == -1) {
      string dn;
      if (val1[0] == '%') {
	perc = 0;
	dn = comp->name + "_" + val1.substr (perc+1, val1.length ());
      }
      else dn = val1.substr (0, perc) + "_" + comp->name 
	+ "_" + val1.substr (perc+1, val1.length ());
      other_name = var1 + "=" + dn;
      if ((at = findAtom (other_name, comp)) != NULL) {
	if (isNull (at->dyn_name))
	  at->dyn_name = new hash_map<const char*, string, hash<const char*>, eqstr> ();
	at->neg = 0;
	(*at->dyn_name)[comp->getName ()] = val1;
      }
      else semError (0, DefHybridParserln(), 74, other_name.c_str ());
    }
    else if (at == NULL)
      semError (0, DefHybridParserln(), 74, other_name.c_str ());
    else {
      semError (0, DefHybridParserln(), 73, $1);
    }
  }
  else semError (0, DefHybridParserln(), 42, filename); 
  $$ = at;
}
;

declaration_cont : VARIABLEDEF var_decl_list {
  /*dot_char = dot_buf_def_cont;
    strcpy(dot_char, "");*/
  hybrid = 1;
}
| PARAMETER var_decl_list
{hybrid = 1;}
| INTERFACE variable_list
{setListcaenFct ($2, $1); hybrid = 1;
   switch ($1) {
    case INPUT:
      inputListcaen = catListcaenVar (inputListcaen, $2);
      break;
    case DISPLAY:
      displayListcaen = catListcaenVar (displayListcaen, $2);
      break;
    case MEASURE:
      measureListcaen = catListcaenVar (measureListcaen, $2);
      break;
    default:
      break;}}
| VARIABLEDEF error var_decl_list
{prodError (Wrong2, Expect1);}
| PARAMETER error var_decl_list
{prodError (Wrong2, Expect1);}
| INTERFACE error variable_list
{prodError (Wrong2, Expect1);}
;

declaratione_cont : VARIABLEDEF error ';'
{prodError (Wrong2, Expect1);}                 /* syn2.ce */
| PARAMETER error ';'
{prodError (Wrong2, Expect1);}
| INTERFACE error ';'
{prodError (Wrong2, Expect1);}
| VARIABLEDEF var_decl_liste
  | PARAMETER var_decl_liste
  | INTERFACE variable_liste {}
;

var_decl_list : var_decl
{}
| var_decl_list ',' var_decl
{}
;

var_decl_liste : var_decle
               | var_decl_list ',' var_decle {}
               | var_decl_list ',' error ';'
{prodError (Wrong3, Expect1);}                   /* syn3.ce */
               | var_decl_list error ';'
{prodError (Wrong3, Expect2);}                   /* syn4.ce */
;

var_decl : variable_cont
{$$ = $1;}
| variable_cont OPREL domain {}
;

var_decle : variable_cont OPREL domaine {}
         | variable_cont OPREL error ';'
{prodError (Wrong4, Expect3);}                     /* syn5.ce */
;

variable_cont : VARIABLE
{$$ = name2Var (&dictionary, $1);}
;

domain : signed_real
{$$ = mkDomReal ($1);}
        | '[' borne_inf ',' borne_sup ']' 
{if ($2 > $4)
   semError (0, DefHybridParserln(), 11, filename); /* "left bound shouldn't be greater than right one." */
 $$ = mkDomRange (mkRange ($2, $4));}
| borne_sup {
$$ = mkDomReal ($1);
}
| borne_inf {
$$ = mkDomReal ($1);
}
| variable_cont
{if (isVarNew ($1)) {
  semError (0, DefHybridParserln(), 14, string (string (getVarNom ($1)) + " in " + string (filename)).c_str ());    /* "undefined variable in domain definition." */
  $$ = NULL;}
 else
   $$ = mkDomVar ($1);}
;

domaine : signed_reale ';'
         | '[' borne_infe ',' borne_sup ']' ';'
         | '[' borne_inf ',' borne_supe ']' ';'
         | '[' borne_inf ',' borne_sup error ';' 
{prodError (Wrong5, Expect4);}                   /* syn6.ce */
         | '[' borne_inf ',' error ';'
{prodError (Wrong5, Expect5);}                   /* syn7.ce */
         | '[' borne_inf error ';'
{prodError (Wrong5, Expect2);}                   /* syn8.ce, syn27.ce */
         | '[' error ';'
{prodError (Wrong5, Expect6);}                   /* syn9.ce */
;

signed_real : REEL
{$$ = atof ($1);}
           | signe REEL
{$$ = $1 ? -atof ($2) : atof ($2);}
;

signed_reale: signe error
{prodError (Wrong6, Expect7);}                   /* syn10.ce */
;

signe: '+'
{$$ = 0;}
     | '-'
{$$ = 1;}
;

borne_inf : signed_real
{$$ = $1;}
          | MOINSINF
{$$ = -DBL_MAX;}
;

borne_infe: signed_reale
;

borne_sup : signed_real
{$$ = $1;}
          | PLUSINF
{$$ = DBL_MAX;}
;

borne_supe: signed_reale
;

variable_list : variable_cont
{if (isVarNew ($1))
  semError (0, DefHybridParserln(), 15, filename);              /* "undefined variable in interface list." */
 $$ = appVariable (NULL, $1);}
              | variable_list ',' variable_cont
{if (isVarNew ($3))
  semError (0, DefHybridParserln(), 15, filename);              /* "undefined variable in interface list." */
 $$ = appVariable ($1, $3);}
;

variable_liste : variable_list ',' error ';' {}
           |  variable_list error ';' {}
;

param_eff_list : param_eff
{$$ = mkListcaenParEff ($1);}                     /* cree une liste de 1 string */
                | param_eff_list ',' param_eff
{$$ = catListcaenParEff ($1, mkListcaenParEff ($3));}
;

param_eff_liste : param_eff_list ',' error
{prodError (Wrong8, Expect9);}                           /* syn16.ce */
                | param_eff_list error
{prodError (Wrong8, Expect10);}                  /* syn11.ce, syn17.ce */
;

param_eff: constante
{if (REAL == getObjType ($1.Obj))
  $$ = mkRealParamEff ($1.Txt);
else
  $$ = mkBoolParamEff ($1.Txt);}
          | VARIABLE
{$$ = mkRealParamEff ($1);}
;

constante : REEL
{$$.Txt = $1;
 $$.Obj = mkObjReal (atof ($1));} 
          | BOOLEEN
{$$.Txt = $1;
 $$.Obj = mkObjBool (a2Bool ($1));}
;

rule : influence
{
  $$ = $1;
}
| stateformula influence {
  cond atco;
  if (isNull (atco = findCond (0, EQ, 0, $1))) {
    atco = mkCondStf ($1);
    /*conditions->push_back(atco);*/
  }
  setInfluCond($2, atco);
  $$ = $2;
}
;

rulee : influencee
       | COND '(' bool_cond ')' influencee
       | COND '(' bool_conde ')' influence ';'
       | COND '(' bool_cond ')' error ';'
{prodError (Wrong9, Expect11);}                           /* syn18.ce */
       | COND '(' bool_cond error ';'
{prodError (Wrong9, Expect12);}                           /* syn19.ce */
       | COND '('  error ';'
{prodError (Wrong9, Expect13);}                           /* syn20.ce */
       | COND  error ';'
{prodError (Wrong9, Expect8);}                            /* syn21.ce */
;

influence : variable_cont INFLUES variable_cont ':' coeff_list
{
  if (isVarNew ($1) || isVarNew ($3)) {
     semError (0, DefHybridParserln(), 16, string (string (getVarNom ($1)) + " or " + string (getVarNom ($3))).c_str ());                  /* "undefined variable in influence." */
    $$ = NULL;}
  else {
    if (isNull ($$ = buildInfluence (comp, $2, $1, $3, $5)))
      DefHybridParsererror ("Error parsing influences.\n");
    /*if (koa_hybrid == 1)*/
    comp->addInfluence ($$);
    /*infToDot($$);*/
  }
}
| variable_cont INFLUES variable_cont
{if (isVarNew ($1) || isVarNew ($3)) {
  semError (0, DefHybridParserln(), 16, 
	    string (string (getVarNom ($1)) + " or " + string(getVarNom ($3))).c_str ());                    /* "undefined variable in influence." */
  $$ = NULL;}
 else {
   if (isNull ($$ = buildInfluence (comp, $2, $1, $3, NULL)))
     DefHybridParsererror ("Error parsing influences.\n");
   /*if (koa_hybrid == 1)*/
   comp->addInfluence ($$);
   /*infToDot($$);*/
 }
}
| signed_real INFLUES variable_cont
{if (isVarNew ($3)) {
  semError (0, DefHybridParserln(), 16, getVarNom ($3));                  /* "undefined variable in influence." */
  $$ = NULL;}
 else {
   cVar = const2Var ($1);
   if (isNull ($$ = buildInfluence (comp, $2, cVar, $3, NULL)))
     DefHybridParsererror ("Error parsing influences.\n");
   /*if (koa_hybrid == 1)*/
   comp->addInfluence ($$);
   /*infToDot($$);*/
}}
;

influencee : variable_cont INFLUES variable_cont ':' coeff_liste {}
           | variable_cont INFLUES error ';'
{prodError (Wrong10, Expect1);}                            /* syn22.ce */
           | signed_real INFLUES error ';'
{prodError (Wrong10, Expect1);}                            /* syn23.ce */
;

coeff_list : coeff
{$$ = mkListcaenCoef ($1);}
           | coeff_list ',' coeff
{$$ = catListcaenCoef ($1, mkListcaenCoef ($3));}
;

coeff_liste : coeffe
            | coeff_list ',' coeffe {}
            | coeff_list ',' error ';'
{prodError (Wrong11, Expect14);}                            /* syn24.ce */
;


coeff : COEFTYPE OPREL domain
{$$ = dom2Coef ($1, $2, $3);}
;

coeffe : COEFTYPE OPREL domaine {}
       | COEFTYPE OPREL error ';'
{prodError (Wrong12, Expect3);}                             /* syn25.ce */
       | COEFTYPE error ';'
{prodError (Wrong12, Expect15);}                            /* syn26.ce */
;

bool_cond_list : bool_cond ',' bool_cond_list {
  /*if (cond_list == 0)
    cond_list = new vector<cond>();
    cond_list->push_back ($1);*/
}
| bool_cond {
  /*if (cond_list == 0)
    cond_list = new vector<cond>();
    cond_list->push_back ($1);*/
}
;

bool_cond : BOOLEEN {
  if (glob == 1) {
    bval = a2Bool ($1);
    $$ = mkCondCte (bval);
    setConditionName ($$, comp);
  }
  else if (isNull ($$ = findCond (bval)))
    DefHybridParsererror ("error: boolean condition not found\n");
}
| equation {
  $$ = expr_cond;
}
| '(' bool_cond ')'
{$$ = $2;}
| bool_cond AND bool_cond
{
  if (glob == 0 && isNull (($$ = findCond ($1, CDET, $3)))) {
     cout << "error line " << DefHybridParserln () << ": and bool_cond not found\n";
     printCondition ($1);
     cout << endl;
     printCondition ($3);
  }
  else if (glob == 1) {
    $$ = mkCondEt ($1, $3);
    setConditionName ($$, comp);
    conditions->push_back ($$);
  }
}
| bool_cond OR bool_cond
{
   if (glob == 0 && isNull (($$ = findCond ($1, CDOU, $3))))
     cout << "error: or bool_cond not found\n";
   else if (glob == 1) {
     $$ = mkCondOu ($1, $3);
     setConditionName ($$, comp);
     conditions->push_back ($$);
   }
}
| '!' bool_cond
{
   if (glob == 0 && isNull (($$ = findCond ($2, CDNON, NULL))))
     cout << "error: ! bool_cond not found\n";
   else if (glob == 1) {
     $$ = mkCondNon ($2);
     setConditionName ($$, comp);
     conditions->push_back ($$);
   }
}
;

bool_conde : variable_cont OPREL domaine {}
           | variable_cont OPREL error
{prodError (Wrong13, Expect3);}                             /* syn28.ce */
           | variable_cont error
{prodError (Wrong13, Expect15);}                            /* syn29.ce */
           | '(' bool_conde ')'
           | '(' error
{prodError (Wrong13, Expect13);}                            /* syn30.ce */
           | bool_conde AND bool_cond
           | bool_cond AND bool_conde {}
           | bool_cond AND error
{prodError (Wrong13, Expect13);}                            /* syn31.ce */
           | bool_conde OR bool_cond
           | bool_cond OR bool_conde {}
           | bool_cond OR error
{prodError (Wrong13, Expect13);}                            /* syn32.ce */
           | '!' bool_conde
           | '!' error
{prodError (Wrong13, Expect13);}                            /* syn33.ce */
;

rule_list : rule
{$$ = mkListcaenInfl ($1);}
           | rule_list ';' rule
{
   $$ = catListcaenInfl ($1, mkListcaenInfl ($3));}
;

rule_liste : rulee
            | rule_list ';' rulee {}
            | rule_list error
{prodError (Wrong14, Expect17);}                            /* syn38.ce */
;

equation : expression OPREL expression
{ 
  if (! isNull ($1) && ! isNull ($3)) {
    if (VAR != getExprType ($1))
      semError (0, DefHybridParserln(), 44, filename);             /* "invalid left hand side in equation." */
    else if (EQ != $2) {
      if (isNull (expr_cond = findCondExpr(1, $1, $2, $3))) {
	cout << "error : expression (condition) not found: " << DefHybridParserln () << endl;
	printExpr ($1);
	cout << endl;
	printExpr ($3);
	cout << endl;
      }
    }
    else { /* EQ */
      if (isNull (expr_cond = findCondExpr(0, $1, $2, $3))
	  && glob == 0) {
	cout << "error : expression (condition) not found\n";
      }
      comp->gVarListcaen = removeGVar (comp->gVarListcaen, getExprGVar ($3));
      setExprGVar ($3, getExprGVar ($1));

      /* printExpr ($3);
	 cout << endl; */
    }
  }
}
;

equatione : expressione OPREL expression ';'
          | expression OPREL expressione ';' {}
          | expression OPREL error ';'
{prodError (Wrong15, Expect21);}                            /* syn40.ce */
;

expression : constante
{
  $$ = mkExprCte ($1.Obj);
  setGVarComp (getExprGVar ($$), comp);
}
| variable_cont
{if (isVarNew ($1)) {
   semError (0, DefHybridParserln(), 18, filename);               /* "undefined variable in expression." */
   $$ = NULL;}
 else if (isNull ($$ = findExpr ($1))) {
   if (isVarConst ($1)) {
     $$ = mkExprCte (getDomObj (getVarDom ($1)));
     setGVarComp (getExprGVar ($$), comp);
     var_expr = catListcaenExpr (var_expr, mkListcaenExpr ($$));
   }
   else {
     if (isNull (Lg2 = isInGVarListcaen ($1, comp->gVarListcaen))) {
       Gv2 = mkGVarVar ($1);
       setGVarComp (Gv2, comp);
       comp->gVarListcaen = catListcaenGVar (comp->gVarListcaen, mkListcaenGVar (Gv2));}
     else { /* isNull  Lg2  */
       Gv2 = getLGGVar (Lg2);
     }
     $$ = mkExprGVar (Gv2);
     var_expr = catListcaenExpr (var_expr, mkListcaenExpr ($$));
   }
 }
}
| '(' expression ')'
{$$ = $2;}
| expression '+' expression
{
   if (isNull ($$ = findExpr ($1, '+', $3)) && glob == 0)
     DefHybridParsererror ("error: + expression (condition) not found\n");
   else if (glob == 1) $$ = buildExprBinOp ('+', $1, $3, comp->globCListcaen, comp->gVarListcaen, numCstrsGlob);
   else $$ = buildExprBinOp ('+', $1, $3, mfCListcaen, comp->gVarListcaen, numMFC);
}
| expression '-' expression
{
   if (isNull ($$ = findExpr ($1, '-', $3)) && !glob)
     DefHybridParsererror ("error: - expression (condition) not found\n");
   else if (glob == 1) $$ = buildExprBinOp ('-', $1, $3, comp->globCListcaen, comp->gVarListcaen, numCstrsGlob);
   else $$ = buildExprBinOp ('-', $1, $3, mfCListcaen, comp->gVarListcaen, numMFC);
}
| expression '*' expression
{
   if (isNull ($$ = findExpr ($1, '*', $3)) && !glob)
     DefHybridParsererror ("error: * expression (condition) not found\n");
   else if (glob == 1) $$ = buildExprBinOp ('*', $1, $3, comp->globCListcaen, comp->gVarListcaen, numCstrsGlob);
   else $$ = buildExprBinOp ('*', $1, $3, mfCListcaen, comp->gVarListcaen, numMFC);
}
| expression '/' expression
{
   if (isNull ($$ = findExpr ($1, '/', $3)) && !glob)
     DefHybridParsererror ("error: / expression (condition) not found\n");
   else if (glob == 1) $$ = buildExprBinOp ('/', $1, $3, comp->globCListcaen, comp->gVarListcaen, numCstrsGlob);
   else $$ = buildExprBinOp ('/', $1, $3, mfCListcaen, comp->gVarListcaen, numMFC);
}
| expression EXPO expression
{
   if (isNull ($$ = findExpr ($1, 'e', $3)) && !glob)
     DefHybridParsererror ("error: e expression (condition) not found\n");
   else if (glob == 1) $$ = buildExprBinOp ('e', $1, $3, comp->globCListcaen, comp->gVarListcaen, numCstrsGlob);
   else $$ = buildExprBinOp ('e', $1, $3, mfCListcaen, comp->gVarListcaen, numMFC);
}
| signe expression %prec EXPO 
{
   if (isNull ($$ = findExpr ($1, $2)) && !glob)
     DefHybridParsererror ("error: sgn expression (condition) not found\n");
   else if (glob == 1) $$ = buildExprSgn ($1, $2, comp->globCListcaen, comp->gVarListcaen, numCstrsGlob);
   else $$ = buildExprSgn ($1, $2, mfCListcaen, comp->gVarListcaen, numMFC);
}
;

expressione: '(' expressione ')'
  | '(' error ';'
{prodError (Wrong16, Expect21);}                            /* syn42.ce */
| expressione '+' expression
  | expression '+' error ';'
{prodError (Wrong16, Expect21);}                            /* syn43.ce */
| expression error ';'
{prodError (Wrong16, Expect20);}                     /* syn1.ce, syn41.ce */
| expressione '-' expression
  | expression '-' error ';'
{prodError (Wrong16, Expect21);}
| expressione '*' expression
  | expression '*' error ';'
{prodError (Wrong16, Expect21);}
| expressione '/' expression
  | expression '/' error ';'
{prodError (Wrong16, Expect21);}
| expressione EXPO expression
           | expression EXPO error ';'
{prodError (Wrong16, Expect21);}
;

init_var_list : init_var
{$$ = mkListcaenInitVar ($1);}
              | init_var_list ',' init_var
{$$ = catListcaenInitVar ($1, mkListcaenInitVar ($3));}
;

init_var_liste : init_vare
               | init_var_list ',' init_vare {}
               | init_var_list ',' error ';'
{prodError (Wrong18, Expect1);}                   /* syn46.ce */
               | init_var_list error ';'
{prodError (Wrong18, Expect2);}                   /* syn44.ce */
;

init_var: variable_cont OPREL domain
{if (isVarNew ($1)) {
  semError (0, DefHybridParserln(), 19, filename);              /* "undefined variable in initialization." */
  $$ = NULL;}
 else if (! isNull ($3))
   $$ = buildInitVar ($1, $3);}
;

init_vare: variable_cont OPREL domaine {}
         | variable_cont OPREL error ';'
{prodError (Wrong19, Expect3);}                    /* syn47.ce */
         | variable_cont error ';'
{prodError (Wrong19, Expect15);}                   /* syn48.ce */
;

param_for_list : param_for
{$$ = mkListcaenParFor ($1);}                /* cree une liste de 1 parametre formel */
               | param_for_list ',' param_for
{$$ = catListcaenParFor ($1, mkListcaenParFor ($3));}
;

param_for_liste : param_fore
                | param_for_list ',' param_fore {}
                | param_for_list ',' error ';' {}
                | param_for_list error ';' {}
;

param_for : VARIABLEDEF VARIABLE
{$$ = mkNumParamFor ($2, NULL);}
          | VARIABLEDEF VARIABLE OPREL domain
{$$ = mkNumParamFor ($2, $4);}
          | PARAMETER VARIABLE
{$$ = mkNumParamFor ($2, NULL);}
          | BOOL PARAMETER VARIABLE
{$$ = mkBoolParamFor ($3);}
;

param_fore : VARIABLEDEF error ';'
           | VARIABLEDEF VARIABLE OPREL domaine
           | VARIABLEDEF VARIABLE OPREL error ';'
           | PARAMETER error ';'
           | BOOL PARAMETER error ';'
           | BOOL error ';'
;

%%

StateFormula* findStf (Atom* at, string op, StateFormula* stf1, StateFormula* stf2) {
  
  if (isNull (stf1)) {                        /* atom */
    for (unsigned int i=0; i<stfs->size (); i++) {
      if ((*stfs)[i]->atoms->size () == 1 
	  && (*(*stfs)[i]->atoms->begin ()).second == at)
	return (*stfs)[i];
    }
  }
  else if (isNull (stf2)) {                   /* atom + stateformula */
    for (unsigned int i=0; i<stfs->size (); i++) {
      if ( ! isNull ((*stfs)[i]->state_formulas)
	   && (*stfs)[i]->operat == op
	   && (*(*stfs)[i]->atoms->begin ()).second == at) {
	for (unsigned int j=0; j<(*stfs)[i]->state_formulas->size (); j++) {
	  if ((*(*stfs)[i]->state_formulas)[j] == stf2)
	    return (*stfs)[i];
	}
	
      }
    }
  }
  else if (isNull (at)) {                     /* stateformula + stateformula */
    /* look in existing stateformula */
    if (! isNull (stf1->state_formulas) 
	&& stf1->operat == stf2->operat
	&& stf1->operat == op) {
      for (unsigned int i=0; i<stf1->state_formulas->size (); i++) {
	if (stf2 == (*stf1->state_formulas)[i])
	  return stf1;
      }
    }
    for (unsigned int i=0; i<stfs->size (); i++) {
      bool s1 = false;
      bool s2 = false;
      if (! isNull ((*stfs)[i]->state_formulas)
	  && (*stfs)[i]->operat == op) {
	for (unsigned int j=0; j<(*stfs)[i]->state_formulas->size (); j++) {
	  if (stf1 == (*(*stfs)[i]->state_formulas)[j]) {
	    s1 = true;
	    if (s1 && s2)
	      return (*stfs)[i];
	  }
	  if (stf2 == (*(*stfs)[i]->state_formulas)[j]) {
	    s2 = true;
	    if (s1 && s2)
	      return (*stfs)[i];
	  }
	}
      }
    }
  }
  return NULL;
}

cond findCond (enum boolVal b) {
  for (unsigned int i=0; i<conditions->size (); i++) {
    if (getCondType ((*conditions)[i]) == CDCTE
	&& getCondValue (Cn1) == b)
      return (*conditions)[i];
  }
  return NULL;
}

cond findCond (cond c1, enum condType ct, cond c2) {
  cond op1=NULL;
  cond op2=NULL;
  if (isNull (c2)) { /* sign */   
    for (unsigned int i=0; i<conditions->size (); i++) {
      if (op1 == c1)
	return (*conditions)[i];
    }
  }
  
  for (unsigned int i=0; i<conditions->size (); i++) {
    op1 = getCondOp1 ((*conditions)[i]);
    op2 = getCondOp2 ((*conditions)[i]);
    if (op1 == c1 && op2 == c2 &&  getCondType ((*conditions)[i]) == ct)
      return (*conditions)[i];
  }
  return 0;
}
  
cond findCond (variable v, enum opRel op, domain d, StateFormula* a) {
  if (isNull (v) && isNull (a)) return 0;
  for (unsigned int i=0; i<conditions->size(); i++) {
    if (isEqCond (v, op, d, a, (*conditions)[i], NULL)) {
      return (*conditions)[i];
    }
  }
  return 0;
}

cond findCond (Atom* at) {
  for (unsigned int i=0; i<conditions->size (); i++)
    if (isEqCond (NULL, NONE, NULL, NULL, (*conditions)[i], at))
      return (*conditions)[i];
  return 0;
}

cond findCondExpr (bool bd, expr e1, enum opRel op, expr e2) {
  expr e;
  listcaenExpr le = NULL;
  listcaenGVar lg = NULL;
  int i=0;

  /*cout << "expr2:\n";
    printExpr (e2);
    cout << endl;*/

  if (bd) {
    /*cout << "building fake egality\n";*/
    e = buildEgSolFunc (e2, op, le, lg, i);  /* fake egality construction */
    /*printExpr (e);
      cout << endl;*/
    setExprGVar (e, getExprGVar (e1));
    free (le);
  }
  else e = e2;
   
  for (unsigned int i=0; i<conditions->size(); i++) {
    if (isEqCond (e, (*conditions)[i]))
      return (*conditions)[i];
  }
  
  return 0;
}

expr findExpr (expr e1, char c, expr e2) {
  /*extern Comp* comp;*/
  listcaenExpr le = comp->condCListcaen;
  expr e;
  enum exprType op;

  switch (c) {
  case '+':
    op=PLUS;
    break;
  case '-':
    op=MOINS;
    break;
  case '*':
    op=MULT;
    break;
  case '/':
    op=DIV;
    break;
  case 'e':
    op=EXP;
    break;
  default :
    op=RIEN;
    break;
  }

  while (! isNull (le)) {
    e = getLEExpr (le);
    if (getExprType (e) == op) {
      if (getExprOp1 (e) == e1 && getExprOp2 (e) == e2) {
	/*cout << "found expr:\n";
	  printExpr (e);
	  cout << endl;*/
	return e;
      }
    }
    le = getLENext (le);
  }
  /*cout << "findExpr: found nothing\n";*/
  return 0;
}

expr findExpr (long s, expr e1) {
  /*extern Comp* comp;*/
  listcaenExpr le = comp->condCListcaen;
  expr e;
  enum exprType op;

  if (s)
    op = SGN;
  else op = RIEN;
  
  while (! isNull (le)) {
    e = getLEExpr (le);
    if (s && getExprType (e) == SGN && getExprOp1 (e) == e1) {
      return e;
    }
    le = getLENext (le);
  }
  /*cout << "findExpr: found nothing\n";*/
  return 0;
}

expr findExpr (variable v) {
  listcaenExpr le = var_expr;
  expr e;
  
  /*cout << "seeking for v: " << getVarNom (v) << endl;
    cout << "le: " << le << endl;*/

  while (! isNull (le)) {
    e = getLEExpr (le);
    if (getExprType (e) == VAR) {
      if (strcmp (getVarNom (getGVarVar (getExprGVar (e))), getVarNom (v)) == 0) {
	/*cout << "found expr:\n";
	  printExpr (e);
	  cout << endl;*/
	return e;
      }
    }
    else if (getExprType (e) == CTE) {
      if (getGVarObj (getExprGVar (e)) == getDomObj (getVarDom (v))) {
	/*cout << "found expr:\n";
	  printExpr (e);
	  cout << endl;*/
	return e;
      }
    }
    le = getLENext (le);
  }
  /*cout << "findExpr: found nothing\n";*/
  return 0;
}

bool isEqCond (expr e, cond c) {
  long r1, r2;
  expr ec;
   
  if (getCondType (c) != CDEXPR) {
    return 0;
  }
  else {
    ec = getCondExpr (c);
    if (getExprType (e) != CTE 
	&& !isNull (getExprGVar (e)) 
	&& (getGVarVar (getExprGVar (e)) == getCondVar (c))) {
	/*&& eqVar(getGVarVar (getExprGVar (e)), getCondVar (c))) {*/
      r1 = r2 = 0;
      expr e1 = getExprOp1 (ec);
      expr e2 = getExprOp2 (ec);
      if (getExprOp1 (e) == e1 && getExprOp2 (e) == e2)
	return 1;
      else if (! isNull (e1) && ! isNull (e2)) {
	if (getExprType (e1) == CTE && getExprType (e2) == CTE 
	    && ! isNull (getGVarObj (getExprGVar (getExprOp1 (e)))) && ! isNull (getGVarObj (getExprGVar (getExprOp2 (e))))) {
	  r1 = eqObj (getGVarObj (getExprGVar (e1)), getGVarObj (getExprGVar (getExprOp1 (e))));
	  r2 = eqObj (getGVarObj (getExprGVar (e2)), getGVarObj (getExprGVar (getExprOp2 (e))));
	}
	else if (getExprType (e1) == CTE
		 && ! isNull (getGVarObj (getExprGVar (getExprOp1 (e))))) {
	  r1 = eqObj (getGVarObj (getExprGVar (e1)), getGVarObj (getExprGVar (getExprOp1 (e))));
	  r2 = (getExprOp2 (e) == e2);
	}
	else if (getExprType (e2) == CTE
		 && ! isNull (getGVarObj (getExprGVar (getExprOp2 (e))))) {
	  r1 = (getExprOp1 (e) == e1);
	  r2 = eqObj (getGVarObj (getExprGVar (e2)), getGVarObj (getExprGVar (getExprOp2 (e))));
	}
	return (r1 == 1) & (r2 == 1);
      }
    }
      /* useless ? */
    else if (getExprType (e) == CTE && getGVarObj (getExprGVar (e)) == getCondDomObj (c)) {
      expr e1 = getExprOp1 (getCondExpr (c));
      expr e2 = getExprOp2 (getCondExpr (c));
      if (getExprOp1 (e) == e1 && getExprOp2 (e) == e2)
	return 1;
    }
  }
  return 0;
}

bool isEqCond(variable v, enum opRel op, domain d, StateFormula* a, cond c, Atom* at) {
  bool r = 0;
  switch (getCondType (c)) {
  case CDEXPR:
  case CDAT:
    if (! isNull (at)) {
      if (at == getCondAtom (c))/* && at->neg)*/
	r = 1;
    }
    else if (! isNull (a)) {
      if (a->atoms->size () == 1 && (*a->atoms->begin ()).second == at && at->neg)
	 /* && ((*a->atoms->begin ()).first == at->neg))*/
	r = 1;
    }
    break;
  case CDOU:  /* to be extended to recursive stateformulas */
    if (a != NULL && a->operat == "or") {
      cond c1 = getCondOp1 (c);
      cond c2 = getCondOp2 (c);
      bool s1 = false;
      bool s2 = false;
      for (multimap<bool, Atom*, eqbool>::iterator it = a->atoms->begin (); 
	   it != a->atoms->end (); it++) {
	if (! s1)
	  s1 = isEqCond (v, op, d, NULL, c1, (*it).second);
	if (! s2)
	  s2 = isEqCond (v, op, d, NULL, c2, (*it).second);
	if (s1 && s2) {
	  r=1;
	  break;
	}
      }
    }
    break;
  case CDET:
     if (a != NULL && a->operat == "and") {
      cond c1 = getCondOp1 (c);
      cond c2 = getCondOp2 (c);
      bool s1 = false;
      bool s2 = false;
      for (multimap<bool, Atom*, eqbool>::iterator it = a->atoms->begin (); 
	   it != a->atoms->end (); it++) {
	if (! s1)
	  s1 = isEqCond (v, op, d, NULL, c1, (*it).second);
	if (! s2)
	  s2 = isEqCond (v, op, d, NULL, c2, (*it).second);
	if (s1 && s2) {
	  r=1;
	  break;
	}
      }
    }
    break;
  default :
    break;
  } /* end switch */
  return r;
}

void flushS (void) {
  while (! estvideS ())
    fprintf (stderr, "%s: syntax error\n", depileS ());
  return;
}

/* make a cond from a state-formula */
cond mkCondStf (StateFormula* stf) {
  /*cout << "entering mkCondStf\n";
    stf->showStateFormula ();
    cout << endl;*/
  cond c, c1, c2;
   Atom *at1, *at2;
   bool b1, b2;

   if (! stf->atoms->empty ()) {
     multimap<bool, Atom*, eqbool>::iterator it = stf->atoms->begin ();
   
     /*if (! isNull (res = findCond (NULL, NONE, 0, stf)))
       return res;*/
     
     if (stf->atoms->size () == 1)
       return mkCondAt ((*it).second, (*it).first, comp);
     

     b1 = (*it).first;
     at1 = (*it).second;
     it++;
     b2 = (*it).first;
     at2 = (*it).second;
     if (stf->operat == "and") {
       c1 = mkCondAt (at1, b1, comp);
       c2 = mkCondAt (at2, b2, comp);
       c = mkCondEt (c1, c2);
     setConditionName (c, comp);
     conditions->push_back (c);
     }
     else if (stf->operat == "or") {
       c1 = mkCondAt (at1, b1, comp);
       c2 = mkCondAt (at2, b2, comp);
       c = mkCondOu (c1, c2);
       setConditionName (c, comp);
       conditions->push_back (c);
     }
     it++;
     while (it != stf->atoms->end ()) {
       at1 = (*it).second;
       b1 = (*it).first;
       c1 = mkCondAt (at1, b1, comp);
       if (stf->operat == "and") {
	 c = mkCondEt (c1, c);
	 setConditionName (c, comp);
	 conditions->push_back (c);
       }
       else if (stf->operat == "or") {
	 c = mkCondOu (c1, c);
	 setConditionName (c, comp);
	 conditions->push_back (c);
       }
       it++;
     }
     return c;
   }
   else {  /* recursive formula */
     StateFormula *stf1, *stf2;
     if (stf->state_formulas->size () >= 2) {   
       stf1 = (*stf->state_formulas)[0];
       stf2 = (*stf->state_formulas)[1];
       c1 = mkCondStf (stf1);
       c2 = mkCondStf (stf2);
       conditions->push_back (c1);
       conditions->push_back (c2);
       if (stf->getOperat () == "or")
	 c = mkCondOu (c1, c2);
       else
	 c = mkCondEt (c1, c2);
       for (unsigned int i=2; i<stf->state_formulas->size (); i++) {
	 if (stf->getOperat () == "or")
	   c = mkCondOu (mkCondStf((*stf->state_formulas)[i]), c);
	 else c = mkCondEt (mkCondStf((*stf->state_formulas)[i]), c);
	 conditions->push_back (c);
       }
       return c;
     }
     else {
       c = mkCondStf ((*stf->state_formulas)[0]);
       conditions->push_back (c);
       return c;
     }
   }
}

cond mkCondAt (Atom* at, bool b, Comp* co) {
  cond Cn;

  /*cout << "at: " << at->getId () << endl;
  cout << "b: " << b << endl;*/

  if (isNull (Cn = findCond (at))) {
    Cn = mkCond ();
    setCondType (Cn, CDAT);
    setCondAtom (Cn, at);
    setConditionName (Cn, co);
    conditions->push_back (Cn);
    
    if (!b) {
      Cn = mkCondNon (Cn);
      setConditionName (Cn, co);
      conditions->push_back (Cn);
    }    

    if (at->getVarType () == "Mode") {
      ModeVar* mdv = (ModeVar*) at->getStateVar ();
      mdv->conditions->push_back (Cn);
    }
    else if (at->getVarType () == "Dependent") {
      DependentVar* dpv = (DependentVar*) at->getStateVar ();
      dpv->conditions->push_back (Cn);
    }
    
    return Cn;
  }
  else {
    if (!b) {
      Cn = mkCondNon (Cn);
      setConditionName (Cn, co);
      conditions->push_back (Cn);
    }
    return Cn;
  }
}

/* create a stateformula as a condition that is valid for all described configurations. 
   unitary mode variables per components for now...
*/
void createModeStf () {
  ModeVar* mdv;
  StateFormula* modesStf;
  
  for (unsigned int i=0; i<comp->state_variables->size (); i++) {
    if ((*comp->state_variables)[i]->type == "Mode") {
      mdv = (ModeVar*) (*comp->state_variables)[i];
      modesStf = new StateFormula ();
      modesStf->setOperat ("or");
      for (unsigned int j=0; j<mdv->atoms_links->size (); j++)
	if ((*mdv->atoms_links)[j]->value != "unknown")          /* unknown mode is not in */
	  modesStf->addAtom ((*mdv->atoms_links)[j]);
      /*cout << "modesStf:";
	modesStf->showStateFormula ();*/
      modes_cond = mkCondStf (modesStf);
      return;
    }
  }
}

void prodError (const char *s, const char *t) {
  int ln;

  /*yyerrok;*/ /* ???? */
  if (! estvideS ()) {                           /* S no deberia estar vacio */
    ln = sprintf (bufErr, "%s: wrong %s",
	     depileS (), s);
    if ('\0' != *t) {                             /* cadena t no esta vacia */
      if (isNull (strchr (t, ' ')))
	sprintf (bufErr+ln, "\n  ...expecting `%s'", t);
      else
	sprintf (bufErr+ln, "\n  ...expecting one of `%s'", t);
    }
    if (estvideS()){ /* no mas syntax errores esperando sus producion mesajes*/
      fprintf (stderr, "%s\n", bufErr);
      while (! estvideP ())
	fprintf (stderr, "%s\n", depileP ());
    }
    else /* estvideS () */
      empileP (mkString (bufErr));
  }
  recover = 1;
  return;
}

void DefHybridParsererror (const char *s) {
   semError (0, DefHybridParserln(), 78, filename);
   exit (1);
}

/*void DefHybridParsererror(char *s) {
  semError (2, DefHybridParserln(), 72);
}*/

/* for compatibility in caen-super.c ... to be deleted */
int parseContFile(const char* deffilename) {
  int res = 0;
  if ((DefHybridParserlval.input = fopen (deffilename, "r")) == NULL) {
    fprintf (stdout, "Can't open file %s\n", deffilename);
    loadError = 1;
  }
  res = DefHybridParserparse();
  fclose (DefHybridParserin);
  return res;
}

void parseHybridDefFile(const char* deffilename, vector<string>* ar, Comp* co) {
  
  args = ar;
  int res = 0;
  filename = deffilename;
  comp = co;
  DefHybridParserrestart (fopen(deffilename, "r"));
  res = DefHybridParserparse();
  fclose (DefHybridParserin);
  comp->instanciated = 1;

}

Atom* getAtomFromPair(string s, vector<pair<string, Atom*> >* vec) {
  for (unsigned int i=0; i<vec->size(); i++) {
    if ((*vec)[i].first == s)
      return (*vec)[i].second;
  }
  return NULL;
}

void transToDot(Transition* tr) {
  char* sprob;
  char bufprob[10];
  sprob = bufprob;
  string com_name = "";
  multimap<bool, Atom*, eqbool>* prea = tr->pre->getAllSignedAtoms();
  multimap<bool, Atom*, eqbool>* posta = tr->post->getAllSignedAtoms();
  for (multimap<bool, Atom*, eqbool>::iterator it1 = prea->begin(); it1 != prea->end(); it1++) {
    if ((*it1).second->getStateVar() == tr->modevar) {
      if ((*it1).second->fail)
	/*dot_buf_def.append((*it1).second->value + " [style=filled, color=red];\n");*/
	dot_buf_def.append((*it1).second->value + " [style=filled, color=dimgray];\n");
      else
	/*dot_buf_def.append((*it1).second->value + " [style=filled, color=green];\n");*/
      dot_buf_def.append((*it1).second->value + " [style=filled, color=whitesmoke];\n");
	
      
      dot_buf_def.append((*it1).second->value + " -> ");
    }
    else if ((*it1).first & (*it1).second->getVarType() == "Command")
      com_name = (*it1).second->value;
  }
  for (multimap<bool, Atom*, eqbool>::iterator it2 = posta->begin(); it2 != posta->end(); it2++) {
    if ((*it2).second->getStateVar() == tr->modevar) {
      dot_buf_def.append((*it2).second->value + " [ ");
    }
  }
  if (tr->getType() == "Fail")
    dot_buf_def.append("style=dotted,");
  /* add label. */
  sprintf(sprob, "%3.2f", tr->proba);
  dot_buf_def.append(" label = \"" + com_name + " (" + string(sprob) + ")\", fontsize=18 ];\n\t");
  sprob = 0; sprob = bufprob;
  delete prea;
  delete posta;
}

void setInfluSymbNameList (listcaenInfl lf, char* na) {
  while (! isNull (lf)) {
    setInfluSymbName (getLIInfl (lf), na);
    lf = getLINext (lf);
  }
}

void infToDotList(listcaenInfl lf) {
  while (! isNull (lf)) {
    infToDot (getLIInfl (lf));
    lf = getLINext (lf);
  }
  return;
}

void infToDot(influence ifl) {
  if (isVarInput(getInfluCause(ifl))) {
    strcat (dot_char, getInfluCause(ifl)->nom);
    strcat (dot_char, " [color=yellow];\n");
    strcat (dot_char, getInfluCause(ifl)->nom);
  }
  else if (isVarMeasure(getInfluCause(ifl))) {
    strcat (dot_char, getInfluCause(ifl)->nom);
    strcat (dot_char, " [color=green];\n");
    strcat (dot_char, getInfluCause(ifl)->nom);
  }
  else
    strcat (dot_char, getInfluCause(ifl)->nom);
  if (isVarMeasure(getInfluEffet(ifl))) {
    strcat (dot_char, getInfluEffet(ifl)->nom);
    strcat (dot_char, " [color=green];\n");
    strcat (dot_char, getInfluEffet(ifl)->nom);
  }
  strcat (dot_char, " -> ");
  strcat (dot_char, getInfluEffet(ifl)->nom);
  strcat (dot_char, " [label = \"");
  strcat (dot_char, getInfluNom(ifl));
  strcat (dot_char, "\"");
  
  /* first order influences. */
  if (getInfluType(ifl) == 1)
    strcat (dot_char, ", color=black");
  
  /* second order influences. */
  if (getInfluType(ifl) == 5)
    strcat (dot_char, ", color=green4");
    
  /* static influences. */
  if (getInfluType(ifl) == 3)
    strcat (dot_char, ", color=orange");

  /* constant influences. */
  if (getInfluType(ifl) == 4)
    strcat (dot_char, ", color=peru");

  /* integral influences. */
  if (getInfluType(ifl) == 2)
    strcat (dot_char, ", color=violetred");
    
  strcat (dot_char, " ];\n");
  return;
}

void toDotDefcont() {
  int i=0;
  char dotf[32];
  char dotn[32];
  while ((dotf[i] = fileInDef[i]) != '.')
    i++;
  dotf[i++] = '\0';
  strcpy(dotn, dotf);
  strcat(dotf, ".dot");
  dotfile = fopen(dotf, "w");
  fprintf (dotfile, "digraph ");
  fprintf (dotfile, dotn);
  fprintf(dotfile, " {\n\trankdir=TB;\n\tsize=\"8,5\"\n\torientation=portrait;\n\tnode [shape = box, style=filled, color=\".7 .3 1.0\"];\n\t");
  fprintf (dotfile, dot_buf_def_cont);
  fprintf (dotfile, "\n}");
  fclose(dotfile);
}

void toDotDef() {
  /*int i=0;
  char dotf[32];
  while ((dotf[i] = current_filename_def[i]) != '.')
    i++;
  dotf[i++] = '\0';
  strcat(dotf, ".dot");
  ofstream f_h(dotf, ios::trunc);
  dot_buf_def.append("}");
  f_h << dot_buf_def;*/
}
