/* $Header: /home/ebenazer/cvsroot/koala/compiler/Attic/varsHybridParser.y,v 1.1.2.34 2003/04/20 12:40:44 ebenazer Exp $
 * Emmanuel Benazera - LAAS-CNRS / DISCO / Toulouse - 2001

*/
%{
#include "../behav/Comp.h"
#include "../behav/StateVar.h"
#include "../behav/CommandVar.h"
#include "../behav/ModeVar.h"
#include "../behav/ObsVar.h"
#include "../behav/CondVar.h"
#include "../caen/caen-objet.h"
#include "../system/koaconf.h"
#include "../itms/itms.h"
#include <stdio.h>
#include <iostream.h>
#include <string.h>
#include <unistd.h>
#include <vector>
#include <stack>
#include <strstream>

#ifndef PARSER_CONTROL
#define PARSER_CONTROL
  struct parser_control {
    vector<pair<string, StateVar*> >* variables_disc;
    const char* def_filename;
  };
#endif

#define YYPARSE_PARAM parm

  void varsHybridParsererror(char *s);
  int varsHybridParserlex();
  int varsHybridParserrestart(FILE* fi);
  void setConditionName (cond cd, Comp* co);
  Comp* parseDef(struct parser_control spc);
  extern FILE* varsHybridParserin;
  extern cond mkCondAt (Atom* at, bool b, Comp* co);
  extern expr findExpr (expr e1, char c, expr e2);
  extern expr findExpr (long s, expr e1);
  extern bool findDefFile(const char* deffilename);
  extern int varsHybridParserln();
  extern void prodError (const char *s, const char *t);
  extern void flushS ();
  extern expr findExpr (variable v);
  extern Comp* comp;
  /*extern listcaenExpr condCListcaen;*/
  extern StateVar* sta_fake;
  string var_name;
  bool vars;
  extern long guards_int;      /* transitions guards on interval non-measured interval value*/
  extern string comp_name_mdl;
  extern string comp_var_name;
  extern itms* reasoner;
  vector<cond>* cond_list;
  extern vector<cond>* condis;
  extern char* nomComp;
  extern arDef conSymb;
  extern char* S1;
  extern char *saux;
  extern boolVal bval;
  extern cond Cn1;
  extern cond expr_cond;
  extern vector<cond>* conditions;
  extern int numCstrsCond;
  extern int numCstrsGlob;
  extern int diffCstrsCond;
  extern listcaenExpr Lex1;
  extern listcaenLong Ll1;
  extern expr Ex1;
  extern gVar Gv1;
  extern gVar Gv2;
  extern listcaenGVar Lg2;
  extern listcaenGVar Lg1;
  extern listcaenExpr var_expr;
  extern domain Dom1;
  extern objet Obj1;
  extern valeur Vl1;
  extern range Rn1;
  Comp* current_comp_def;
  extern const char* filename;
%}

%union {
  long Long;
  enum objType ObjType;
  double Double;
  enum boolVal BoolVal;
  char *String;
  enum opRel OpRel;
  objet Objet;
  struct {
    objet Obj;
    char *Txt;
  } ObjAndString;
  variable Variable;
  listcaenVar ListcaenVar;
  domain Domain;
  enum interType InterType;
  enum coefType CoefType;
  coef Coef;
  listcaenCoef ListcaenCoef;
  cond Cond;
  enum influType InfluType;
  /*influence Influence;
  listcaenInfl ListcaenInfl;*/
  initVar InitVar;
  listcaenInitVar ListcaenInitVar;
  paramFor ParamFor;
  listcaenParFor ListcaenParFor;
  paramEff ParamEff;
  listcaenParEff ListcaenParEff;
  expr Expr;

  char* name;
  FILE* input;
  FILE* decl_input;
  vector<string>* declarations; /**< store model files headers. */
  vector<pair<string, string> >* others_imports; /**< store components in'others' imports. */
  vector<string>* shared; /**< store exogeneous shared variables. */
  ModeVar* modevar;
  ObsVar* obsvar;
  CommandVar* cmdvar;
  DependentVar* depvar;
  CondVar* condvar;
  char* var;
  char* varchar;
  Atom* tom;
  listcaenExpr ListcaenExpr;
  CommandVar* cmd1;
  MapFunc* mf;
  vector<mapfVar>* mvfl;
  mapfVar mv;
}

%{
		
#define Wrong1 "statement"
#define Wrong2 "declaration_cont"
#define Wrong3 "var_decl_list"
#define Wrong4 "var_decl"
#define Wrong5 "domain"
#define Wrong6 "signed_real"
#define Wrong7 "instanciation"
#define Wrong8 "param_eff_list"
#define Wrong9 "rule"
#define Wrong10 "influence"
#define Wrong11 "coeff_list"
#define Wrong12 "coeff"
#define Wrong13 "bool_cond"
#define Wrong14 "rule_list"
#define Wrong15 "equation"
#define Wrong16 "expression"
#define Wrong17 "initialization"
#define Wrong18 "init_var_list"
#define Wrong19 "init_var"
#define Wrong20 "model"

#define Expect0 ""
#define Expect1 "VARIABLE"
#define Expect2 ","
#define Expect3 "[ VARIABLE REEL + -"
#define Expect4 "]"
#define Expect5 "+oo REEL + -"
#define Expect6 "-oo REEL + -"
#define Expect7 "REEL"
#define Expect8 "("
#define Expect9 "BOOLEEN VARIABLE REEL"
#define Expect10 ", )"
#define Expect11 "VARIABLE REEL + -"
#define Expect12 "& | )"
#define Expect13 "( BOOLEEN VARIABLE !"
#define Expect14 "COEFTYPE"
#define Expect15 "OPREL"
#define Expect16 "CONDITION } VARIABLE REEL + -"
#define Expect17 ";"
#define Expect18 "CONDITION VARIABLE REEL + -"
#define Expect19 "{"
#define Expect20 "OPREL + - * / **"
#define Expect21 "( VARIABLE BOOLEEN REEL + -"
#define Expect22 "BOOL PARAMETER VARIABLEDEF"
#define Expect23 ", )"
#define Expect24 "CONDITION } VARIABLE INSTANCE REEL + -"

%}
		
%token INTEGER
%token STATEFORMULA
%token <name> STR
%token IMP
%token NEXT COMPONENT RE OR AND COMMENTARIES CMIN CPLUS VARASSIGN
%token <declarations> USE
%token TRANSITIONS CONSTRAINTS VARDEF NOMINAL IDLE FAIL CIN COUT OTHERS
%token <shared> SHARED
%token <others_imports> IMPORT
%token <var> VARIABLE
%token <var> NVARIABLE
%token <modevar> MODEVAR
%token <obsvar> OBSVAR
%token <cmdvar> COMMANDVAR
%token <depvar> DEPENDENTVAR
%token CONDVAR

%token BOOL COND EXPO EXO INIT INSTANCE MODELE MOINSINF PARAMETER PLUSINF VARIABLEDEF ';' ',' '(' ')' '[' ']' ':' '{' '}'
 
%token <String> BOOLEEN
%token <CoefType> COEFTYPE
%token <InfluType> INFLUES
%token <InterType> INTERFACE
%token <String> REEL
%token <OpRel> OPREL
  
%type <Long> signe
%type <Double> signed_real
%type <Double> borne_inf
%type <Double> borne_sup
%type <ObjAndString> constante
%type <Variable> variable_cont
%type <Variable> var_decl
%type <ListcaenVar> variable_list
%type <ListcaenVar> var_decl_list
%type <Domain> domain
%type <Coef> coeff
%type <ListcaenCoef> coeff_list
%type <cmd1> commands_decl
%type <Cond> bool_cond
%type <InitVar> init_var
%type <ListcaenInitVar> init_var_list
%type <ParamFor> param_for
%type <ListcaenParFor> param_for_list
%type <ParamEff> param_eff
%type <ListcaenParEff> param_eff_list
%type <Expr> expression
%type <condvar> conds_decl
%type <tom> atom
%type <mf> mapping_func
%type <mvfl> mapping_var_list
%type <mv> mapping_var

%left  OR   /* beware when parsing logical constraints !!! */
%left  AND  /* idem !!! */
%right '!'
%left '+' '-'
%left '*' '/'
%left EXPO

%start program

%%

program: 	declaration program
                | caenprogram
		|		       
		;				

declaration:    use_decl component_decl ';' '{' constructor_decl '}' VARDEF '{' vars_decl '}' CONSTRAINTS '{' forms_decl '}' rules TRANSITIONS '{' transition '}'	{}
| use_decl component_decl ';' '{' constructor_decl '}' VARDEF '{' vars_decl '}' CONSTRAINTS '{' rules '}' TRANSITIONS '{' transition '}'	{current_comp_def->numCond = numCond;}
| use_decl component_decl '{' constructor_decl '}' VARDEF '{' vars_decl '}' CONSTRAINTS '{' forms_decl '}' rules TRANSITIONS '{' transition '}'	{}
| use_decl component_decl '{' constructor_decl '}' VARDEF '{' vars_decl '}' CONSTRAINTS '{' rules '}' TRANSITIONS '{' transition '}'	{current_comp_def->numCond = numCond;}
;

use_decl:  USE {
  string defname;
  for (unsigned int i=0; i<$1->size(); i++) {
    defname = (*$1)[i] + ".def";
    if (!findDefFile(defname.c_str())) {
      semError (0, varsHybridParserln (), 77, defname.c_str());
      return 1;
    }
  }
  delete $1;
  numCond = 0;
}
|
;

caenprogram : statement
            | caenprogram statement
            | statemente
            | caenprogram statemente
{prodError (Wrong1, Expect0);                       /* syn1.ce */
 flushS ();}
;

statement : declaration_cont ';'
| instanciation
| VARIABLE ':' rule ';' {free ($1);}
| VARIABLE ':' '{' rule_list ';' '}' {free ($1);}
| VARIABLE ':' stateformula '{' rule_list ';' '}' {free ($1);}
| equation ';' {}
| INIT init_var_list ';' {}
| model '}' {}
;

statemente: declaratione_cont
          | instanciatione
          | VARIABLE ':' rulee {}
          | VARIABLE ':' '{' rule_liste ';' '}' {}
          | VARIABLE ':' '{' rule_list ';' error {}
{prodError (Wrong1, Expect16);}                       /* syn34.ce */
          | VARIABLE ':' '{' rule_list error '}'
{prodError (Wrong1, Expect17);}                       /* syn35.ce, syn36.ce */
          | VARIABLE ':' '{' error '}'
{prodError (Wrong1, Expect18);}                       /* syn37.ce */
          | VARIABLE ':' COND '(' bool_cond ')' '{' rule_liste ';' '}' {}
          | VARIABLE ':' COND '(' bool_conde ')' '{' rule_list ';' '}' {}
          | VARIABLE ':' COND '(' bool_cond ')' '{' rule_list ';' error
{prodError (Wrong1, Expect16);}                         /* syn55.ce */
          | VARIABLE ':' COND '(' bool_cond ')' '{' rule_list error '}'
{prodError (Wrong1, Expect17);}                         /* syn56.ce, syn57.ce */
          | VARIABLE ':' COND '(' bool_cond ')' '{' error '}'
{prodError (Wrong1, Expect18);}                         /* syn58.ce */
          | equatione
{prodError (Wrong1, Expect0);}
          | INIT init_var_liste
          | INIT error ';'
{prodError (Wrong17, Expect1);}                       /* syn45.ce */
          | modele '}'
          | model MODELE
{/*fclose (cpMod);*/
 semError (0, varsHybridParserln(), 50, filename);                /* imbrication of models not allowed. */
}
          | model INSTANCE
{/*fclose (cpMod);*/
 semError (0, varsHybridParserln(), 51, filename);          /* instanciation not allowed inside a model. */
}
;

component_decl:  	COMPONENT STR       {
	    comp = new Comp(comp_var_name); /* name of the component = name of its variable... */
	    comp->type = $2;
	    comp->var_name = comp_var_name;
	    current_comp_def = comp;
	    vars = true;
	    if (conditions == NULL)
	      conditions = new vector<cond> ();
	    if (condis == NULL)
	      condis = new vector<cond> ();
}
;

constructor_decl: CIN EXO ':' commands_decl constructor_decl {
  current_comp_def->cmd_in = new vector<CommandVar*> ();
  current_comp_def->cmd_in->push_back ($4);
  $4->exo = 1;
}
| CIN ':' commands_decl constructor_decl {
  current_comp_def->cmd_in = new vector<CommandVar*> ();
  current_comp_def->cmd_in->push_back ($3);
}
| CIN ':' SHARED CMIN ';' constructor_decl {}
| CIN ':' SHARED CPLUS ';' constructor_decl
| COUT ':' commands_decl constructor_decl {
  $3->out = 1;
}
| COUT ':' constructor_decl
| CIN ':' constructor_decl
| IMPORT {}
|
;

commands_decl: COMMANDVAR {
  current_comp_def->addStateVar ($1);
  ((struct parser_control*)parm)->variables_disc->push_back(pair<string, StateVar*>($1->name, $1));
  $$ = $1;
}
;

vars_decl: MODEVAR vars_decl {
  bool unknown = false;
  cond ca;
  current_comp_def->addStateVar ($1);
  if (conf_get ("discrete") == 0) {
    for (unsigned int i=0; i<$1->atoms_links->size (); i++) {   /* create conditions for each mode variable... */
      ca = mkCondAt ((*$1->atoms_links)[i], true, current_comp_def);
    }
  }
  for (unsigned int i=0; i<$1->atoms_links->size (); i++)
    if ((*$1->atoms_links)[i]->value == "unknown")
      unknown = true;
  if (! unknown) /* no unknown mode found */
    semError (2, varsHybridParserln (), 81, (current_comp_def->name + ": " + string (filename)).c_str ());
  ((struct parser_control*)parm)->variables_disc->push_back(pair<string, StateVar*>($1->name, $1));
}
| OBSVAR vars_decl {
  current_comp_def->addStateVar ($1);
  ((struct parser_control*)parm)->variables_disc->push_back(pair<string, StateVar*>($1->name, $1));
}
| DEPENDENTVAR vars_decl	{
  current_comp_def->addStateVar ($1);
  ((struct parser_control*)parm)->variables_disc->push_back(pair<string, StateVar*>($1->name, $1));
}
| conds_decl vars_decl {
  current_comp_def->addStateVar ($1);
  ((struct parser_control*)parm)->variables_disc->push_back (pair<string, StateVar*>($1->name, $1));
}
| declaration_cont ';' vars_decl
| declaration_cont vars_decl;
| {vars = false}
;

conds_decl: CONDVAR VARIABLE '(' bool_cond_list ')' ';' {
  string nu, at_val, symbn;
  Atom* cat;
  variable common = getCondVar ((*cond_list)[0]);

  if (! (isVarInput (common) || isVarMeasure (common))) {
    semError (2, varsHybridParserln(), 47, (string (getVarNom (common)) + " in " + string (filename)).c_str ());           /*variable in bool_cond should better be input or measure */
    guards_int = 1;
  }
  varsHybridParserlval.condvar = new CondVar();
  varsHybridParserlval.condvar->vars->push_back(common);
  varsHybridParserlval.condvar->setName ($2);
  symbn = string ($2);
  varsHybridParserlval.condvar->setSymbName (symbn.substr (symbn.find (".")+1, symbn.size ()));
  
  for (unsigned int i=0; i<cond_list->size(); i++) {
    condis->push_back ((*cond_list)[i]);
    if ((getCondType ((*cond_list)[i]) == CDOU)
	|| (getCondType ((*cond_list)[i]) == CDET)) /* set a var ref */
      setCondVar ((*cond_list)[i], getCondVar ((*cond_list)[i]->op1));
    
    if (!eqVar (common, getCondVar ((*cond_list)[i])))
      semError (0, varsHybridParserln(), 63, filename);
    else {
      std::ostrstream os;
      os << cond_list->size()-1-i;
      nu = string(os.str(), os.tellp());
      at_val = varsHybridParserlval.condvar->name.substr(varsHybridParserlval.condvar->name.find (".")+1,
							 varsHybridParserlval.condvar->name.size ()) + nu;
      varsHybridParserlval.condvar->addValue(at_val);
      cat = new Atom(varsHybridParserlval.condvar, at_val, 
		     varsHybridParserlval.condvar->name + "=" + at_val, false);
      setCondAtom ((*cond_list)[i], cat);
      varsHybridParserlval.condvar->conditions->push_back((*cond_list)[i]);
    }
  } /* end for cond_list */
  varsHybridParserlval.condvar->default_state = (*varsHybridParserlval.condvar->values.begin ());
  varsHybridParserlval.condvar->current_state = &varsHybridParserlval.condvar->default_state;
  $$ = varsHybridParserlval.condvar;
  delete cond_list;
  cond_list = 0;
}
;

forms_decl: 	formula ';' forms_decl
| formula ';'
| formula
;

rules :          VARIABLE ':' rule ';' rules {}
| VARIABLE ':' '{' rule_list ';' '}' rules {}
| VARIABLE ':' stateformula '{' rule_list ';' '}' rules {} /* | VARIABLE ':' COND '(' bool_cond ')' '{' rule_list ';' '}' rules */
| equation ';' rules {}
| INIT init_var_list ';' rules {}
|
;

transition:	VARIABLE ':' '{' NOMINAL stateformula next_statement transition_coeffs ';' mapping_func_list '}' transition {}
| VARIABLE ':' '{' NOMINAL stateformula NEXT stateformula transition_coeffs ';' mapping_func_list '}' transition {}
| IDLE stateformula NEXT stateformula transition_coeffs ';' transition {}
| VARIABLE ':' '{' FAIL stateformula NEXT stateformula REEL ';' mapping_func_list '}' transition {}
| {}
;

next_statement: NEXT stateformula next_statement
| NEXT stateformula ';'
;

transition_coeffs: REEL REEL {}
| REEL {}  /* cost can be omitted but not the probability */
;

mapping_func_list : mapping_func {}
| mapping_func_list ';' mapping_func {}
| {}
;

mapping_var_list : mapping_var {}
| mapping_var_list ',' mapping_var {}
| {}
;

mapping_func : stateformula ':' mapping_var_list {}
| mapping_var_list {}
| {}
;

mapping_var: variable_cont OPREL expression {
  /*if (isVarNew ($1)) {
    semError (0, varsHybridParserln(), 19, filename);    */          /* "undefined variable in initialization." */
  /*}*/
}
;

formula: stateformula IMP stateformula {}
| stateformula IMP VARASSIGN VARIABLE OPREL VARIABLE {}
| '(' formula ')' AND formula {}
| '(' formula ')' OR formula {}
| '(' formula ')' {}
;

stateformula: 	'(' atom ')' OR stateformula {}
| '(' atom ')' AND stateformula {}
| '(' atom ')' {}
| COND bool_cond {}
| '(' stateformula ')' AND stateformula {}
| '(' stateformula ')' OR stateformula {}
| '(' stateformula ')' {}
;

atom: VARIABLE OPREL STR {}
;

declaration_cont : VARIABLEDEF var_decl_list {}
| PARAMETER var_decl_list {
  setListcaenConst ($2); /*hybrid = 1;*/
}
| INTERFACE variable_list {}
| VARIABLEDEF error var_decl_list {}
| PARAMETER error var_decl_list {}
| INTERFACE error variable_list {}
;

declaratione_cont : VARIABLEDEF error ';'
{prodError (Wrong2, Expect1);}                 /* syn2.ce */
             | PARAMETER error ';'
{prodError (Wrong2, Expect1);}
             | INTERFACE error ';'
{prodError (Wrong2, Expect1);}
             | VARIABLEDEF var_decl_liste
             | PARAMETER var_decl_liste
             | INTERFACE variable_liste {}
;

var_decl_list : var_decl {
	       $$ = appVariable (NULL, $1);      
}
| var_decl_list ',' var_decl {
  $$ = appVariable ($1, $3);
}
;

var_decl_liste : var_decle
               | var_decl_list ',' var_decle {}
               | var_decl_list ',' error ';'
{prodError (Wrong3, Expect1);}                   /* syn3.ce */
               | var_decl_list error ';'
{prodError (Wrong3, Expect2);}                   /* syn4.ce */
;

var_decl : variable_cont {}
{
  if (! isNull ($1) && ! isVarNew ($1)) {
    semError (0, varsHybridParserln(), 13, (string (getVarNom ($1)) + " in " + string (filename)).c_str());                     /* "variable already defined." */
  }
  else if (! isNull ($1)) {
    setVarDom ($1, mkDomRange (maxRange));
    current_comp_def->addVariable ($1);
  }
}
| variable_cont OPREL domain
{
  if (! isNull ($1) && ! isVarNew ($1)) {
    semError (0, varsHybridParserln(), 13, (string (getVarNom ($1)) + " in " + string (filename)).c_str());                 /* "variable already defined." */
  }
  else if (! isNull ($1)) {
    $$ = dom2Var ($1, $2, $3);
    current_comp_def->addVariable ($1);
  }
}
;

var_decle : variable_cont OPREL domaine {}
| variable_cont OPREL error ';' {}
{prodError (Wrong4, Expect3);}                     /* syn5.ce */
;

variable_cont : VARIABLE {
  variable vartmp;
  string symbn = string ($1);
  if (symbn.substr (0, symbn.find (".")) == current_comp_def->var_name) {
    vartmp = name2Var (&dictionary, mkString (string ($1).c_str()));
    setVarSymbName (vartmp, mkString(symbn.substr (symbn.find (".")+1, symbn.size ()).c_str()));
  }
  else vartmp = NULL;
  $$ = vartmp;
}
;

domain : signed_real
{$$ = mkDomReal ($1);}
        | '[' borne_inf ',' borne_sup ']' 
{if ($2 > $4)
   semError (0, varsHybridParserln(), 11, filename); /* "left bound shouldn't be greater than right one." */
 $$ = mkDomRange (mkRange ($2, $4));}
| borne_sup {
$$ = mkDomReal ($1);
}
| borne_inf {
$$ = mkDomReal ($1);
}
| variable_cont
{if (! isNull ($1) && isVarNew ($1)) {
  semError (0, varsHybridParserln(), 14, (string (getVarNom ($1)) + " in " + string (filename)).c_str());     /* "undefined variable in domain definition." */
  $$ = NULL;}
 else {$$ = mkDomVar ($1);}
}
;

domaine : signed_reale ';'
| '[' borne_infe ',' borne_sup ']' ';'
| '[' borne_inf ',' borne_supe ']' ';'
| '[' borne_inf ',' borne_sup error ';' 
{prodError (Wrong5, Expect4);}                   /* syn6.ce */
| '[' borne_inf ',' error ';'
{prodError (Wrong5, Expect5);}                   /* syn7.ce */
| '[' borne_inf error ';'
{prodError (Wrong5, Expect2);}                   /* syn8.ce, syn27.ce */
| '[' error ';'
{prodError (Wrong5, Expect6);}                   /* syn9.ce */
;

signed_real : REEL
{$$ = atof ($1);}
| signe REEL
{$$ = $1 ? -atof ($2) : atof ($2);}
;

signed_reale: signe error
{prodError (Wrong6, Expect7);}                   /* syn10.ce */
;

signe: '+' {}
| '-' {}
;

borne_inf : signed_real {}
| MOINSINF {}
;

borne_infe: signed_reale
;

borne_sup : signed_real {}
| PLUSINF {}
;

borne_supe: signed_reale
;

variable_list : variable_cont {
  if (! isNull ($1) && isVarNew ($1))
    semError (0, varsHybridParserln(), 15, filename);
}
| variable_list ',' variable_cont {
  if (! isNull ($1) && isVarNew ($3))
    semError (0, varsHybridParserln(), 15, filename);
}
;

variable_liste : variable_list ',' error ';' {}
           |  variable_list error ';' {}
;

instanciation : VARIABLE ':' INSTANCE VARIABLE '(' param_eff_list ')' ';' {
  free ($1);
}
;

instanciatione : VARIABLE ':' INSTANCE VARIABLE '(' param_eff_liste ';' {}
           | VARIABLE ':' INSTANCE VARIABLE '(' error ';' 
{prodError (Wrong7, Expect9);}                           /* syn12.ce */
           | VARIABLE ':' INSTANCE VARIABLE error ';'
{prodError (Wrong7, Expect8);}                           /* syn13.ce */
           | VARIABLE ':' INSTANCE error ';'
{prodError (Wrong7, Expect1);}                           /* syn14.ce */
           | VARIABLE ':' error ';'
{prodError (Wrong7, Expect24);}                           /* syn15.ce */
;

param_eff_list : param_eff {}
| param_eff_list ',' param_eff {}
;

param_eff_liste : param_eff_list ',' error
{prodError (Wrong8, Expect9);}                           /* syn16.ce */
                | param_eff_list error
{prodError (Wrong8, Expect10);}                  /* syn11.ce, syn17.ce */
;

param_eff: constante {}
| VARIABLE {}
;

constante : REEL {
   $$.Txt = $1;
   $$.Obj = mkObjReal (atof ($1));
}
| BOOLEEN {
   $$.Txt = $1;
   $$.Obj = mkObjBool (a2Bool ($1));
}
;

rule : influence {}
| stateformula influence {} /* | COND '(' bool_cond ')' influence */
/*| '(' atom ')' influence {}*/
;

rulee : influencee
       | COND '(' bool_cond ')' influencee
       | COND '(' bool_conde ')' influence ';'
       | COND '(' bool_cond ')' error ';'
{prodError (Wrong9, Expect11);}                           /* syn18.ce */
       | COND '(' bool_cond error ';'
{prodError (Wrong9, Expect12);}                           /* syn19.ce */
       | COND '('  error ';'
{prodError (Wrong9, Expect13);}                           /* syn20.ce */
       | COND  error ';'
{prodError (Wrong9, Expect8);}                            /* syn21.ce */
;

influence : variable_cont INFLUES variable_cont ':' coeff_list {
  if ((! isNull ($1) && isVarNew ($1)) || (! isNull ($3) && isVarNew ($3)))
     semError (0, varsHybridParserln(), 16, string (string (getVarNom ($1)) + " or " + string (getVarNom ($3))).c_str ());                  /* "undefined variable in influence." */
}
| variable_cont INFLUES variable_cont {
  if ((! isNull ($1) && isVarNew ($1)) || (! isNull ($3) && isVarNew ($3)))
    semError (0, varsHybridParserln(), 16, 
	      string (string (getVarNom ($1)) + " or " + string(getVarNom ($3))).c_str ());                    /* "undefined variable in influence." */
}
| signed_real INFLUES variable_cont {
  if (! isNull ($3) && isVarNew ($3))
    semError (0, varsHybridParserln(), 16, getVarNom ($3));
}
;

influencee : variable_cont INFLUES variable_cont ':' coeff_liste {}
           | variable_cont INFLUES error ';'
{prodError (Wrong10, Expect1);}                            /* syn22.ce */
           | signed_real INFLUES error ';'
{prodError (Wrong10, Expect1);}                            /* syn23.ce */
;

coeff_list : coeff {}
| coeff_list ',' coeff {}
;

coeff_liste : coeffe
            | coeff_list ',' coeffe {}
            | coeff_list ',' error ';'
{prodError (Wrong11, Expect14);}                            /* syn24.ce */
;

coeff : COEFTYPE OPREL domain {}
;

coeffe : COEFTYPE OPREL domaine {}
       | COEFTYPE OPREL error ';'
{prodError (Wrong12, Expect3);}                             /* syn25.ce */
       | COEFTYPE error ';'
{prodError (Wrong12, Expect15);}                            /* syn26.ce */
;

bool_cond_list : bool_cond ',' bool_cond_list {
  if (cond_list == 0)
    cond_list = new vector<cond>();
  cond_list->push_back ($1);
}
| bool_cond {
  if (cond_list == 0)
    cond_list = new vector<cond>();
  cond_list->push_back ($1);
}
;

bool_cond : BOOLEEN {
  if (vars) {
    bval = a2Bool ($1);
    $$ = mkCondCte (bval);
    setConditionName ($$, current_comp_def);
    conditions->push_back ($$);
  }
}
| equation {$$ = expr_cond;}
| '(' bool_cond ')' {$$ = $2;}
| bool_cond AND bool_cond {
   if (vars) {
      $$ = mkCondEt ($1, $3);
      setConditionName ($$, current_comp_def);
      conditions->push_back ($$);}
}
| bool_cond OR bool_cond {
   if (vars) {
      $$ = mkCondOu ($1, $3);
      setConditionName ($$, current_comp_def);
      conditions->push_back ($$);}
}
| '!' bool_cond {
  if (vars) {
     $$ = mkCondNon ($2);
     setConditionName ($$, current_comp_def);
     conditions->push_back ($$);}
}
;

bool_conde : variable_cont OPREL domaine {}
           | variable_cont OPREL error
{prodError (Wrong13, Expect3);}                             /* syn28.ce */
           | variable_cont error
{prodError (Wrong13, Expect15);}                            /* syn29.ce */
           | '(' bool_conde ')'
           | '(' error
{prodError (Wrong13, Expect13);}                            /* syn30.ce */
           | bool_conde AND bool_cond
           | bool_cond AND bool_conde {}
           | bool_cond AND error
{prodError (Wrong13, Expect13);}                            /* syn31.ce */
           | bool_conde OR bool_cond
           | bool_cond OR bool_conde {}
           | bool_cond OR error
{prodError (Wrong13, Expect13);}                            /* syn32.ce */
           | '!' bool_conde
           | '!' error
{prodError (Wrong13, Expect13);}                            /* syn33.ce */
;

rule_list : rule {}
| rule_list ';' rule {}
;

rule_liste : rulee
| rule_list ';' rulee {}
| rule_list error
{prodError (Wrong14, Expect17);}                            /* syn38.ce */
;

equation : expression OPREL expression {
  if (! isNull ($1) && ! isNull ($3)) {
    if (VAR != getExprType ($1))
    semError (0, varsHybridParserln(), 44, filename);             /* "invalid left hand side in equation." */
  else if (EQ != $2 && vars) {
    expr eg = buildEgSolFunc ($3, $2, current_comp_def->condCListcaen, current_comp_def->gVarListcaen, numCstrsCond);        /* make egality equivalent relations */
    expr_cond = mkCondExpr ($1, $2, eg);            /* create condition */  
    setConditionName (expr_cond, current_comp_def);
    current_comp_def->condCListcaen = catListcaenExpr (current_comp_def->condCListcaen, mkListcaenExpr (eg));
    numCstrsCond++;
    for (int i=diffCstrsCond; i<numCstrsCond; i++)
      expr_cond->le = catListcaenLong (expr_cond->le, mkListcaenLong (i)); /* reference expr into cond */     
    conditions->push_back (expr_cond);
    diffCstrsCond = numCstrsCond;
    current_comp_def->gVarListcaen = removeGVar (current_comp_def->gVarListcaen, getExprGVar (eg));
    setExprGVar (eg, getExprGVar ($1));
  }
  else if (vars) { /* EQ */
    semError (2, varsHybridParserln(), 66, filename);    /* warning : equalities not recommended in conditions. */
    expr_cond = mkCondExpr ($1, $2, $3);      /* create condition */
    setConditionName (expr_cond, current_comp_def);
    for (int i=diffCstrsCond; i<numCstrsCond; i++)
      expr_cond->le = catListcaenLong (expr_cond->le, mkListcaenLong (i)); /* reference expr into cond */
    conditions->push_back (expr_cond);
    diffCstrsCond = numCstrsCond;
    current_comp_def->gVarListcaen = removeGVar (current_comp_def->gVarListcaen, getExprGVar ($3));
    setExprGVar ($3, getExprGVar ($1));
  }
}
}
;

equatione : expressione OPREL expression ';'
          | expression OPREL expressione ';' {}
          | expression OPREL error ';'
{prodError (Wrong15, Expect21);}                            /* syn40.ce */
;

expression : constante 
{$$ = mkExprCte ($1.Obj);
 catListcaenExpr (var_expr, mkListcaenExpr ($$));
}
          | variable_cont
{if (! isNull ($1) && isVarNew ($1)) {
  semError (0, varsHybridParserln(), 79, (string (getVarNom ($1)) + " in " + string (filename)).c_str());               /* "undefined variable in expression." */
  $$ = NULL;}
 else if (! isNull ($1)) {
   if (isNull ($$ = findExpr ($1)) & vars) {
     if (isVarConst ($1)) {
       $$ = mkExprCte (getDomObj (getVarDom ($1)));
       var_expr = catListcaenExpr (var_expr, mkListcaenExpr ($$));
     }
     else {
       if (isNull (Lg2 = isInGVarListcaen ($1, current_comp_def->gVarListcaen))) {
	 Gv2 = mkGVarVar ($1);
	 setGVarComp (Gv2, current_comp_def);
	 current_comp_def->gVarListcaen = catListcaenGVar (current_comp_def->gVarListcaen, mkListcaenGVar (Gv2));}
       else { /* isNull  Lg2  */
	 Gv2 = getLGGVar (Lg2);
       }
       $$ = mkExprGVar (Gv2);
       var_expr = catListcaenExpr (var_expr, mkListcaenExpr ($$));
     }
   }
   /*else $$ = NULL;*/
 }
 else $$ = NULL; /* Beware */
}
          | '(' expression ')'
{$$ = $2;}
          | expression '+' expression
{
  if (isNull ($$ = findExpr ($1, '+', $3)) & vars)
      $$ = buildExprBinOp ('+', $1, $3, current_comp_def->condCListcaen, current_comp_def->gVarListcaen, numCstrsCond);
}
          | expression '-' expression
{
  if (isNull ($$ = findExpr ($1, '-', $3)) & vars)
     $$ = buildExprBinOp ('-', $1, $3, current_comp_def->condCListcaen, current_comp_def->gVarListcaen, numCstrsCond);
}
          | expression '*' expression
{
  if (isNull ($$ = findExpr ($1, '*', $3)) & vars)
      $$ = buildExprBinOp ('*', $1, $3, current_comp_def->condCListcaen, current_comp_def->gVarListcaen, numCstrsCond);
}
          | expression '/' expression
{
  if (isNull ($$ = findExpr ($1, '/', $3)) & vars)
      $$ = buildExprBinOp ('/', $1, $3, current_comp_def->condCListcaen, current_comp_def->gVarListcaen, numCstrsCond);
}
          | expression EXPO expression
{
  if (isNull ($$ = findExpr ($1, 'e', $3)) & vars)
     $$ = buildExprBinOp ('e', $1, $3, current_comp_def->condCListcaen, current_comp_def->gVarListcaen, numCstrsCond);
}
          | signe expression %prec EXPO 
{
  if (isNull ($$ = findExpr ($1, $2)) & vars)
      $$ = buildExprSgn ($1, $2, current_comp_def->condCListcaen, current_comp_def->gVarListcaen, numCstrsCond);
}
;

expressione: '(' expressione ')'
           | '(' error ';'
{prodError (Wrong16, Expect21);}                            /* syn42.ce */
           | expressione '+' expression
           | expression '+' error ';'
{prodError (Wrong16, Expect21);}                            /* syn43.ce */
           | expression error ';'
{prodError (Wrong16, Expect20);}                     /* syn1.ce, syn41.ce */
           | expressione '-' expression
           | expression '-' error ';'
{prodError (Wrong16, Expect21);}
           | expressione '*' expression
           | expression '*' error ';'
{prodError (Wrong16, Expect21);}
           | expressione '/' expression
           | expression '/' error ';'
{prodError (Wrong16, Expect21);}
           | expressione EXPO expression
           | expression EXPO error ';'
{prodError (Wrong16, Expect21);}
;

init_var_list : init_var {}
| init_var_list ',' init_var {}
;

init_var_liste : init_vare
               | init_var_list ',' init_vare {}
               | init_var_list ',' error ';'
{prodError (Wrong18, Expect1);}                   /* syn46.ce */
               | init_var_list error ';'
{prodError (Wrong18, Expect2);}                   /* syn44.ce */
;

init_var: variable_cont OPREL domain {
  if (! isNull ($1) && isVarNew ($1))
    semError (0, varsHybridParserln(), 19, filename);              /* "undefined variable in initialization." */
}
;

init_vare: variable_cont OPREL domaine {}
         | variable_cont OPREL error ';'
{prodError (Wrong19, Expect3);}                    /* syn47.ce */
         | variable_cont error ';'
{prodError (Wrong19, Expect15);}                   /* syn48.ce */
;

model: MODELE VARIABLE '(' param_for_list ')' '{' {}
;

modele: MODELE VARIABLE '(' param_for_liste ')' '{'
| MODELE VARIABLE '(' param_for_list ')' error '{'            
| MODELE VARIABLE '(' param_for_list error '{'
| MODELE VARIABLE '(' error '{'
| MODELE VARIABLE error '{'
| MODELE error '{'
;

param_for_list : param_for {}
| param_for_list ',' param_for {}
;

param_for_liste : param_fore
                | param_for_list ',' param_fore {}
                | param_for_list ',' error ';' {}
                | param_for_list error ';' {}
;

param_for : VARIABLEDEF VARIABLE {}
| VARIABLEDEF VARIABLE OPREL domain {}
| PARAMETER VARIABLE {}
| BOOL PARAMETER VARIABLE {}
;

param_fore : VARIABLEDEF error ';'
           | VARIABLEDEF VARIABLE OPREL domaine
           | VARIABLEDEF VARIABLE OPREL error ';'
           | PARAMETER error ';'
           | BOOL PARAMETER error ';'
           | BOOL error ';'
;

%%
 
void varsHybridParsererror(char *s) {
  cerr << filename << ": ";
  semError (0, varsHybridParserln(), 72, filename);
}

void setConditionName (cond cd, Comp* co) {
  string cn, nc;
  std::ostrstream os;
  os << getCondNum (cd); nc = string (os.str(), os.tellp());
  cn = co->var_name + ".c_" + nc;
  setCondName (cd, mkString (cn.c_str ()));
}

Comp* parseDef(struct parser_control spc, const char* filen) {
  filename = filen;
  varsHybridParserrestart (fopen (filename, "r"));
  if (1 == varsHybridParserparse((void*) &spc))
    return NULL;
  fclose (varsHybridParserin);
  return current_comp_def;
}
