/* koala-super.h */

#include <errno.h>
#include <sys/wait.h>
#ifdef HAVE_READLINE
#include <readline/history.h>
#endif
#include <ctype.h>
#include "caen-algo.h"

/* C++ includes. */
#include "../system/config.h"
#include "../behav/Trajectory.h"
#include "../system/DataManager.h"
#include "../system/koaconf.h"
#include "../itms/mdlChk.h"
#include "../itms/itms.h"
#include "pi_gen.h"
#include <stdio.h>
#include <iostream.h>
#include <string.h>
#include <unistd.h>
#include <vector>
#include <strstream>
#include <fstream>

/*#define DEBUG*/
#define CENAME "caen"
#define KOALANAME "koala"
/*#ifdef GNU*/
#ifdef DEBUG
#define CCEXEDEB "c++ -g -Wall -Wno-deprecated -DDEBUG -I"
#define CCEXERTDEB "c++ -g -Wall -Wno-deprecated -I"
#else /* DEBUG */
#define CCEXEDEB "c++ -g -Wno-deprecated -I"
#define CCEXE "c++ -Wno-deprecated -I"
#define CCEXEOPT "c++ -O4 -Wno-deprecated -I"
#define CCEXEOPT1 "c++ -O2 -Wno-deprecated -I"
#define CCEXERTDEB "c++ -g -Wno-deprecated -I"
#define CCEXERT "c++ -Wno-deprecated -I"
#define CCEXERTOPT "c++ -O4 -Wno-deprecated -I"
#define CCEXERTOPT1 "c++ -O2 -Wno-deprecated -I"
#endif /* DEBUG */
#define CCEXEFIN " -lkoalaexec ../../nelder/nelder.o ../../nelder/optim.o -lcerunt -lkoalasysrt -litmsrt -lkoalabehrt -lkoala -lreadline -ltermcap" /* -liberty -ll -lm"*/

enum ordre {DEBUT, DECLA, IOINIT, REGLE};
itms* reasoner;

/* external declarations */
extern FILE *yyin;
extern FILE *ModelHybridParserin;
extern long nligne;
extern char fileIn[40];
extern long braceLevel;
extern string nodestr;
extern string initstr;
extern string gvarstr;
extern string condstr;
extern string condcstr;
extern string globstr;
extern string cross_ref;
extern string mfexprstr;
extern string cl_header;
extern vector<string>* cl_files;
extern vector<cond>* condis;
extern vector<pair<string, StateVar*> >* variables_disc;
extern vector<pair<string, variable> >* variables_cont;
extern map<int, component>* oco;

/* config */
extern int koa_hybrid;
extern int pi;  /* prime implicants option */

extern long ceLoad (char *);
extern long cePrint (char *);
extern long ceGraph (char *);
extern long ceCompile (char *);
extern long koaGenerateDef (char *, Comp* co);
extern long koaGenerateRunT ();
extern long ceExec (char *);
extern long ceReload (char *);
extern long ceUnload (char *);
extern long ceOptions (char *);
extern int DefHybridParserparse ();
extern int DefHybridParserlex ();
extern int DefHybridParserln ();
extern int ModelHybridParserparse();
extern int ModelHybridParserlex();
extern int parseModelFile(const char*);
extern int parseContFile(const char*);

