#include "mdlChk.h"

#ifdef PROBAS
mdlChk::mdlChk() : DataManager() {
  corresp_var = new hash_map<const char*, bdd*, hash<const char*>, eqstr>();
  corresp_atoms = new hash_map<const char*, bdd, hash<const char*>, eqstr>();
  corresp_comps =  new hash_map<const char*, bdd, hash<const char*>, eqstr>();
}
#else
mdlChk::mdlChk() : DataManager() {
}
#endif

#ifdef PROBAS
void mdlChk::encode(vector<Clause*>* cls, bdd &curr_bdd, unsigned int size) {
  int var_i = 0;
  int count = 0;
  bdd* cl_bdd;
  var = new bdd*[size];
  /* initialize corresp_comps. */
  for (hash_map<const char*, Comp*, hash<const char*>, eqstr>::iterator it = active_comps->begin(); it != active_comps->end(); it++) {
    (*corresp_comps)[(*it).second->getName()] = bddtrue;
  }
  /* iterate through clauses. */
  for (unsigned int i=0; i<cls->size(); i++) {
    /* create the encoded clause. */
    cl_bdd = encodeClause((*cls)[i], var_i, count, curr_bdd);
    /* add corresponding clause to component correpondences table. */
    (*corresp_comps)[(*cls)[i]->ref_comp->getName()] &= *cl_bdd;
    //cout << "comp : " << (*cls)[i]->ref_comp->getName() << " -- count : " << bdd_nodecount(*(*corresp_comps)[(*cls)[i]->ref_comp->getName()]) << endl;
    /* add the encoded clause to the global BDD. */
    curr_bdd &= *cl_bdd;
    //cout << "node count curr_bdd : " << bdd_nodecount(curr_bdd) << endl;
  } 
  //cout << "var_i : " << var_i << endl;
}
bdd* mdlChk::encodeClause(Clause* cla, int &var_i, int &count, bdd &curr_bdd) {
  bdd* res = new bdd(bddfalse);
  for (multimap<bool, Atom*, eqbool>::iterator cl_it = cla->cl->begin(); cl_it != cla->cl->end(); cl_it++) {
    if ((*corresp_var)[(*cl_it).second->stateVar->name.c_str()] == NULL) {
      //(*corresp_var)[(*cl_it).second->stateVar->name.c_str()] = new bdd[(*cl_it).second->stateVar->values.size()](bddtrue);
      (*corresp_var)[(*cl_it).second->stateVar->name.c_str()] = new bdd[(*cl_it).second->stateVar->values.size()];
      /* add the new BDD to var. */
      var[var_i] = (*corresp_var)[(*cl_it).second->stateVar->name.c_str()];
      /* construct encoded internal clause. */
      encodeInternalClauses((*cl_it).second->stateVar, var_i, count, curr_bdd);
      //cout << "var_i is going up : " << var_i << endl;
      var_i++;
      count++;
      }
    if ((*cl_it).first) *res |= !(*corresp_atoms)[(*cl_it).second->getId()];
    else *res |= (*corresp_atoms)[(*cl_it).second->getId()];
  }
  return res;
}
void mdlChk::encodeInternalClauses(StateVar* sta, int &var_i, int &count, bdd &curr_bdd) {
  int var_j = 0;
  bdd* internal_bdd;
  for (unsigned int i=0; i<sta->atoms_links->size(); i++) {
    //cout << "var_i : " << var_i << " -- var_j : " << var_j << endl;
    var[var_i][var_j] = bdd_ithvar(count);
    (*corresp_atoms)[(*sta->atoms_links)[i]->getId()] = var[var_i][var_j];
    //cout << "var_i : " << var_i << " -- var_j : " << var_j << endl;
    cout << count << " : ";
    (*sta->atoms_links)[i]->showAtom(0);
    cout << endl;
    //(*table_atoms)[count] = (*sta->atoms_links)[i];
    var_j++;
    if (!(i == sta->atoms_links->size() - 1))
      count++;
  }
  /* encode internal clauses. */
  for (unsigned int j=0; j<sta->internal_clauses->size(); j++) {
      internal_bdd = encodeClause((*sta->internal_clauses)[j], var_i, count, curr_bdd);
      curr_bdd &= *internal_bdd;
      (*corresp_comps)[(*sta->internal_clauses)[j]->ref_comp->getName()] &= *internal_bdd;
  }
}

void mdlChk::runChk(vector<Clause*>* cls) {
  cout << "running model checker\n";
  cout << "cls size : " << cls->size() << endl;
  //bdd_init(10000, 1000);
  //cout << "init successful !\n";
  //bdd_setvarnum(31);
  //cout << bddset << pb << endl;
  //cout << "beginning encoding\n";
  pb = bddtrue;
  encode(cls, pb, 12);
  //pb = bdd(global);
  //pb &= (*corresp_atoms)["bus_p.failed_status=ok"];
  //pb &= (*corresp_atoms)["vdu.mode=on"];
  //pb &= (*corresp_atoms)["vdu.cmdin=open"];
  //pb &= (*corresp_atoms)["v1.mode=closed"];
  //pb &= (*corresp_atoms)["v1.mode=open"];
  //pb &= (*corresp_atoms)["v2.mode=closed"];
  //pb &= !(*corresp_atoms)["vdu.cmdout=none"];
  //pb &= (*corresp_atoms)["v1.vflow=zero"];
  //pb &= (*corresp_atoms)["v2.vflow=zero"];
  //pb &= (*corresp_atoms)["vdu.mode=failed"];
  cout << "bdd_nodecount pb : " <<  bdd_nodecount(pb) << endl;
  cout << "There are " << bdd_satcount(pb) << " solutions.\n";
  bdd solution = bdd_satone(pb);
  cout << bddset << solution << endl;
  //bdd_printset(pb);
  bdd_done();

}
/* rewritten for const char* from the bdd package. */
int mdlChk::bdd_fnload(const char *fname, bdd* root)
{
   FILE *ifile;
   int ok;

   if ((ifile=fopen(fname,"r")) == NULL)
      return -1;

   ok = bdd_load(ifile, *root);
   fclose(ifile);
   return ok;
}
/* rewritten for const char* from the bdd package. */
int mdlChk::bdd_fnsave(const char *fname, bdd r)
{
   FILE *ofile;
   int ok;

   if ((ofile=fopen(fname,"w")) == NULL)
      return -1;

   ok = bdd_save(ofile, r);
   fclose(ofile);
   return ok;
}
/* compile a set of clause at start time. */
void mdlChk::compileBddClauses(vector<Clause*>* cls, unsigned int size) {
  /* try to load the bdd from a file (model_name + .bdd). */
  /*string bf_name = model_name + ".bdd";
    bdd* glob = new bdd(bddtrue);;
    if (bdd_fnload(bf_name.c_str(), glob) == 0) {
    cout << "[mdlChk] --> bdd file found and loaded.\n";
    }*/
  /* else compile it. */
  //else {
    cout << "[mdlChk] --> no bdd file detected.\n" << endl;
    bdd_init(10000, 1000);
    bdd_setvarnum(size);
    global = bddtrue;
    encode(cls, global, size);
    cout << "[mdlChk] --> bdd clauses encoding successful.\n";
    /* try to save it to a file. */
    /*if (bdd_fnsave(bf_name.c_str(), global) == 0) {
      cout << "[mdlChk] --> bdd successfully saved.\n";
      }
      }*/
}
/**
* compute the conditional probability : p(v=vi|tau_v).
*/
double mdlChk::computeCondProb(TrajEl* elt, Transition* trans, State* wkst, hash_map<const char*, TrajEl*, hash<const char*>, eqstr>* alchg) {
  bdd cglobal;
  bdd cpb;
  //cpb = bdd(global);
  cpb = bdd(*wkst->bdd_state);
  /* add the elements of the post of the transition to the denominator and the numerator. */
  vector<Atom*>* p_all = trans->post->getAllAtoms();
  for (unsigned int i=0; i<p_all->size(); i++) {
    cpb &= (*corresp_atoms)[(*p_all)[i]->getId()];
  }
  delete p_all;
  //cglobal = bdd(pb); //???
  cglobal = bdd(cpb);
  /* add current elt to the numerator. 
   * if the elt's label hasn't already been modified, anticipate by negating the label.
   */
  if (alchg->count(elt->getId()) == 0) {
    if (elt->getLabel() == "true")
      cpb &= !(*corresp_atoms)[elt->getId()];
    else if (elt->getLabel() == "false")
      cpb &= (*corresp_atoms)[elt->getId()];
  }
  else {
    if (elt->getLabel() == "true")
      cpb &= (*corresp_atoms)[elt->getId()];
    else if (elt->getLabel() == "false")
      cpb &= !(*corresp_atoms)[elt->getId()];
  }
  double num = bdd_satcount(cpb);
  double den = bdd_satcount(cglobal);
  /*cout << "computing sols on cpb : " << num << endl;
    cout << "computing sols on cglobal : " << den << endl;*/
  //cout << "returning conditional probability : " << num/den << endl;
  return num/den;
}
double mdlChk::computeProb(Atom* at) { //useless
  //bdd cpb = bdd(pb);
  //bdd cglobal = bdd(pb);
  bdd cglobal = bdd(global);
  cglobal &= (*corresp_atoms)[at->getId()];
  //cpb &= (*corresp_atoms)[at->getId()];
  double res = (double)bdd_satcount(cglobal) / (double)bdd_satcount(global);
  //double res = (double)bdd_satcount(cpb) / (double)bdd_satcount(global);
  //double res = (double)bdd_satcount(cpb) / (double)bdd_satcount(cglobal);
  //double res = 1;
  //cout << "computeProba : " << res << endl;
  return res;
}
void mdlChk::addNode(State* wkst, const char* id, string lab) {
  //cout << "adding as " << lab << " to pb : " << id << endl;
  if (lab == "true")
    *wkst->pb &= (*corresp_atoms)[id];
  else if (lab == "false")
    *wkst->pb &= !(*corresp_atoms)[id];
}
void mdlChk::addNode(bdd* bdpb, const char* id, string lab) {
  if (lab == "true")
    *bdpb &= (*corresp_atoms)[id];
  else if (lab == "false")
    *bdpb &= !(*corresp_atoms)[id];
}
bdd* mdlChk::makeStateBdd(State* wkst) {
  wkst->bdd_state = new bdd(bddtrue);
  for (hash_map<const char*, Comp*, hash<const char*>, eqstr>::iterator it = wkst->comps->begin(); it != wkst->comps->end(); it++) {
    //cout << "[mdlChk] --> makeStateBdd : adding comp " << (*it).first << endl;
    *wkst->bdd_state &= (*corresp_comps)[(*it).first];
    }
  return wkst->bdd_state;
}
/* add a comp to an existing bdd_state. */
void mdlChk::addToStateBdd(State* wkst, const char* comp_id) {
  if (wkst->bdd_state == NULL)
    wkst->bdd_state = new bdd(bddtrue);
  //cout << "[mdlChk] --> addToStateBdd : adding comp " << comp_id << endl;
  *wkst->bdd_state &= (*corresp_comps)[comp_id];
}
/* in replacement of the bdd package bdd_satcountset. */
double mdlChk::satcountset(bdd state_bdd, unsigned int unused) {
  return bdd_satcount(state_bdd) / pow((double) 2, (double) active_atoms->size() - (double) unused);
}
#endif
