#include "valve_cont.h"

valve_cont::valve_cont(string na, vector<CommandVar*>* in, vector<CommandVar*>* out, tank2* t2i) : Comp(na) {
		cmd_in = in;
		cmd_out = out;
	t2 = t2i;
	init();
}
valve_cont::~valve_cont() {

}
void valve_cont::init() {

	set<string> valve_cont_cmdin_values;
	valve_cont_cmdin_values.insert("fl");
	valve_cont_cmdin_values.insert("fsc");
	valve_cont_cmdin_values.insert("fso");
	valve_cont_cmdin_values.insert("none");
	valve_cont_cmdin_values.insert("v1_close");
	valve_cont_cmdin_values.insert("v1_off");
	valve_cont_cmdin_values.insert("v1_on");
	valve_cont_cmdin_values.insert("v1_open");
	valve_cont_cmdin_values.insert("v2_close");
	valve_cont_cmdin_values.insert("v2_open");
	string cmdinname = name + ".cmdin";
	valve_cont_cmdin = new CommandVar(cmdinname, valve_cont_cmdin_values, "none", this);
		addStateVar(valve_cont_cmdin);

	valve_cont_cmdin_none = new Atom(valve_cont_cmdin, "none", name + ".cmdin=none");
		(*atoms)["valve_cont_cmdin_none"]=valve_cont_cmdin_none;
		valve_cont_cmdin_v1_on = new Atom(valve_cont_cmdin, "v1_on", name + ".cmdin=v1_on");
		(*atoms)["valve_cont_cmdin_v1_on"]=valve_cont_cmdin_v1_on;
		valve_cont_cmdin_v1_off = new Atom(valve_cont_cmdin, "v1_off", name + ".cmdin=v1_off");
		(*atoms)["valve_cont_cmdin_v1_off"]=valve_cont_cmdin_v1_off;
		valve_cont_cmdin_v1_open = new Atom(valve_cont_cmdin, "v1_open", name + ".cmdin=v1_open");
		(*atoms)["valve_cont_cmdin_v1_open"]=valve_cont_cmdin_v1_open;
		valve_cont_cmdin_v1_close = new Atom(valve_cont_cmdin, "v1_close", name + ".cmdin=v1_close");
		(*atoms)["valve_cont_cmdin_v1_close"]=valve_cont_cmdin_v1_close;
		valve_cont_cmdin_v2_open = new Atom(valve_cont_cmdin, "v2_open", name + ".cmdin=v2_open");
		(*atoms)["valve_cont_cmdin_v2_open"]=valve_cont_cmdin_v2_open;
		valve_cont_cmdin_v2_close = new Atom(valve_cont_cmdin, "v2_close", name + ".cmdin=v2_close");
		(*atoms)["valve_cont_cmdin_v2_close"]=valve_cont_cmdin_v2_close;
		valve_cont_cmdin_fsc = new Atom(valve_cont_cmdin, "fsc", name + ".cmdin=fsc");
		(*atoms)["valve_cont_cmdin_fsc"]=valve_cont_cmdin_fsc;
		valve_cont_cmdin_fso = new Atom(valve_cont_cmdin, "fso", name + ".cmdin=fso");
		(*atoms)["valve_cont_cmdin_fso"]=valve_cont_cmdin_fso;
		valve_cont_cmdin_fl = new Atom(valve_cont_cmdin, "fl", name + ".cmdin=fl");
		(*atoms)["valve_cont_cmdin_fl"]=valve_cont_cmdin_fl;
		cmd_out = new vector<CommandVar*>();
	cmd_out->push_back (valve_cont_cmdin);
	
	set<string> valve_cont_cmdout_values;
	valve_cont_cmdout_values.insert("fl");
	valve_cont_cmdout_values.insert("fsc");
	valve_cont_cmdout_values.insert("fso");
	valve_cont_cmdout_values.insert("none");
	valve_cont_cmdout_values.insert("v1_close");
	valve_cont_cmdout_values.insert("v1_off");
	valve_cont_cmdout_values.insert("v1_on");
	valve_cont_cmdout_values.insert("v1_open");
	valve_cont_cmdout_values.insert("v2_close");
	valve_cont_cmdout_values.insert("v2_open");
	string cmdoutname = name + ".cmdout";
	valve_cont_cmdout = new CommandVar(cmdoutname, valve_cont_cmdout_values, "none", this);
		addStateVar(valve_cont_cmdout);

	valve_cont_cmdout_none = new Atom(valve_cont_cmdout, "none", name + ".cmdout=none");
		(*atoms)["valve_cont_cmdout_none"]=valve_cont_cmdout_none;
		valve_cont_cmdout_v1_on = new Atom(valve_cont_cmdout, "v1_on", name + ".cmdout=v1_on");
		(*atoms)["valve_cont_cmdout_v1_on"]=valve_cont_cmdout_v1_on;
		valve_cont_cmdout_v1_off = new Atom(valve_cont_cmdout, "v1_off", name + ".cmdout=v1_off");
		(*atoms)["valve_cont_cmdout_v1_off"]=valve_cont_cmdout_v1_off;
		valve_cont_cmdout_v1_open = new Atom(valve_cont_cmdout, "v1_open", name + ".cmdout=v1_open");
		(*atoms)["valve_cont_cmdout_v1_open"]=valve_cont_cmdout_v1_open;
		valve_cont_cmdout_v1_close = new Atom(valve_cont_cmdout, "v1_close", name + ".cmdout=v1_close");
		(*atoms)["valve_cont_cmdout_v1_close"]=valve_cont_cmdout_v1_close;
		valve_cont_cmdout_v2_open = new Atom(valve_cont_cmdout, "v2_open", name + ".cmdout=v2_open");
		(*atoms)["valve_cont_cmdout_v2_open"]=valve_cont_cmdout_v2_open;
		valve_cont_cmdout_v2_close = new Atom(valve_cont_cmdout, "v2_close", name + ".cmdout=v2_close");
		(*atoms)["valve_cont_cmdout_v2_close"]=valve_cont_cmdout_v2_close;
		valve_cont_cmdout_fsc = new Atom(valve_cont_cmdout, "fsc", name + ".cmdout=fsc");
		(*atoms)["valve_cont_cmdout_fsc"]=valve_cont_cmdout_fsc;
		valve_cont_cmdout_fso = new Atom(valve_cont_cmdout, "fso", name + ".cmdout=fso");
		(*atoms)["valve_cont_cmdout_fso"]=valve_cont_cmdout_fso;
		valve_cont_cmdout_fl = new Atom(valve_cont_cmdout, "fl", name + ".cmdout=fl");
		(*atoms)["valve_cont_cmdout_fl"]=valve_cont_cmdout_fl;
		cmd_out = new vector<CommandVar*>();
	cmd_out->push_back (valve_cont_cmdout);
	
	set<string> valve_cont_mode_values;
	valve_cont_mode_values.insert("failed");
	valve_cont_mode_values.insert("ok");
	valve_cont_mode_values.insert("unknown");
	string modename = name + ".mode";
	valve_cont_mode = new ModeVar(modename, valve_cont_mode_values, "ok", this);
		addStateVar(valve_cont_mode);

	valve_cont_mode_ok = new Atom(valve_cont_mode, "ok", name + ".mode=ok");
		(*atoms)["valve_cont_mode_ok"]=valve_cont_mode_ok;
		valve_cont_mode_failed = new Atom(valve_cont_mode, "failed", name + ".mode=failed");
		(*atoms)["valve_cont_mode_failed"]=valve_cont_mode_failed;
		valve_cont_mode_unknown = new Atom(valve_cont_mode, "unknown", name + ".mode=unknown");
		(*atoms)["valve_cont_mode_unknown"]=valve_cont_mode_unknown;
	c_1 = mkCond ();
	setCondType (c_1, 6);
	setCondCTE (c_1, 0);
	setCondAtom (c_1, valve_cont_mode_ok);
	;
	c_2 = mkCond ();
	setCondType (c_2, 6);
	setCondCTE (c_2, 0);
	setCondAtom (c_2, valve_cont_mode_failed);
	;
	c_3 = mkCond ();
	setCondType (c_3, 6);
	setCondCTE (c_3, 0);
	setCondAtom (c_3, valve_cont_mode_unknown);
	;
		valve_cont_mode->conditions->insert(pair<const char*, int>(valve_cont_mode_ok->getId(), 48));
	valve_cont_mode_ok->cond = 1;
		valve_cont_mode->conditions->insert(pair<const char*, int>(valve_cont_mode_failed->getId(), 49));
	valve_cont_mode_failed->cond = 1;
		valve_cont_mode->conditions->insert(pair<const char*, int>(valve_cont_mode_unknown->getId(), 50));
	valve_cont_mode_unknown->cond = 1;
		external_clauses = new vector<Clause*>();

	valve_cont_stf50 = new StateFormula();
	valve_cont_stf50->addAtom (valve_cont_mode_ok, 1);
 /* gen */
	valve_cont_stf50->setOperat("");

	valve_cont_stf51 = new StateFormula();
	valve_cont_stf51->addAtom (valve_cont_mode_unknown, 1);
 /* gen */
	valve_cont_stf51->setOperat("");

	valve_cont_t25 = new Transition(valve_cont_stf50, valve_cont_stf51, "Fail", 0.01, 0, 0);
valve_cont_t25->trans_id = 25;
	
	addTransitionToC(valve_cont_t25);
	
	valve_cont_stf52 = new StateFormula();
	valve_cont_stf52->addAtom (valve_cont_mode_ok, 1);
 /* gen */
	valve_cont_stf52->setOperat("");

	valve_cont_stf53 = new StateFormula();
	valve_cont_stf53->addAtom (valve_cont_mode_failed, 1);
 /* gen */
	valve_cont_stf53->setOperat("");

	valve_cont_t26 = new Transition(valve_cont_stf52, valve_cont_stf53, "Fail", 0.09, 0, 0);
valve_cont_t26->trans_id = 26;
	
	addTransitionToC(valve_cont_t26);
	
	valve_cont_stf54 = new StateFormula();
	valve_cont_stf54->addAtom (valve_cont_mode_unknown, 1);
 /* gen */
	valve_cont_stf54->setOperat("");

	valve_cont_stf55 = new StateFormula();
	valve_cont_stf55->addAtom (valve_cont_mode_unknown, 1);
 /* gen */
	valve_cont_stf55->setOperat("");

	valve_cont_t27 = new Transition(valve_cont_stf54, valve_cont_stf55, "Nominal", 1, 0, 1);
valve_cont_t27->trans_id = 27;
	
	addTransitionToC(valve_cont_t27);
	
	valve_cont_stf56 = new StateFormula();
	valve_cont_stf56->addAtom (valve_cont_mode_failed, 1);
 /* gen */
	valve_cont_stf56->setOperat("");

	valve_cont_stf57 = new StateFormula();
	valve_cont_stf57->addAtom (valve_cont_mode_failed, 1);
 /* gen */
	valve_cont_stf57->setOperat("");

	valve_cont_t28 = new Transition(valve_cont_stf56, valve_cont_stf57, "Nominal", 1, 0, 1);
valve_cont_t28->trans_id = 28;
	
	addTransitionToC(valve_cont_t28);
	
	valve_cont_stf58 = new StateFormula();
	valve_cont_stf58->addAtom (valve_cont_mode_ok, 1);
 /* gen */
	valve_cont_stf58->setOperat("");

	valve_cont_stf59 = new StateFormula();
	valve_cont_stf59->addAtom (valve_cont_mode_ok, 1);
 /* gen */
	valve_cont_stf59->setOperat("");

	valve_cont_t29 = new Transition(valve_cont_stf58, valve_cont_stf59, "Nominal", 0.99, 0, 1);
valve_cont_t29->trans_id = 29;
	
	addTransitionToC(valve_cont_t29);
	
}
