#include "therm_rt.h"

using namespace std;

void startinit (Scheduler* sMM) {

	R1 = new room("room", 0, 0, T1);
	R1->type = "room";
	R1->var_name = "R1";
	T1 = new therm("thermostat", 0, 0, R1);
	T1->type = "therm";
	T1->var_name = "T1";
	sMM->addComp(R1);
	sMM->addComp(T1);

	Clause* cl1 = new Clause (T1);
	cl1->addAtomRef(T1->therm_mode_on, true);
	cl1->addAtomRef(T1->therm_mode_off, true);
	cl1->setInternal(1);
	T1->therm_mode->internal_clauses->push_back(cl1);
sMM->cls->push_back (cl1);
	
	Clause* cl2 = new Clause (T1);
	cl2->addAtomRef(T1->therm_mode_stuck_on, true);
	cl2->addAtomRef(T1->therm_mode_off, true);
	cl2->setInternal(1);
	T1->therm_mode->internal_clauses->push_back(cl2);
sMM->cls->push_back (cl2);
	
	Clause* cl3 = new Clause (T1);
	cl3->addAtomRef(T1->therm_mode_stuck_off, true);
	cl3->addAtomRef(T1->therm_mode_off, true);
	cl3->setInternal(1);
	T1->therm_mode->internal_clauses->push_back(cl3);
sMM->cls->push_back (cl3);
	
	Clause* cl4 = new Clause (T1);
	cl4->addAtomRef(T1->therm_mode_unknown, true);
	cl4->addAtomRef(T1->therm_mode_off, true);
	cl4->setInternal(1);
	T1->therm_mode->internal_clauses->push_back(cl4);
sMM->cls->push_back (cl4);
	
	Clause* cl5 = new Clause (T1);
	cl5->addAtomRef(T1->therm_mode_stuck_on, true);
	cl5->addAtomRef(T1->therm_mode_on, true);
	cl5->setInternal(1);
	T1->therm_mode->internal_clauses->push_back(cl5);
sMM->cls->push_back (cl5);
	
	Clause* cl6 = new Clause (T1);
	cl6->addAtomRef(T1->therm_mode_stuck_off, true);
	cl6->addAtomRef(T1->therm_mode_on, true);
	cl6->setInternal(1);
	T1->therm_mode->internal_clauses->push_back(cl6);
sMM->cls->push_back (cl6);
	
	Clause* cl7 = new Clause (T1);
	cl7->addAtomRef(T1->therm_mode_unknown, true);
	cl7->addAtomRef(T1->therm_mode_on, true);
	cl7->setInternal(1);
	T1->therm_mode->internal_clauses->push_back(cl7);
sMM->cls->push_back (cl7);
	
	Clause* cl8 = new Clause (T1);
	cl8->addAtomRef(T1->therm_mode_stuck_off, true);
	cl8->addAtomRef(T1->therm_mode_stuck_on, true);
	cl8->setInternal(1);
	T1->therm_mode->internal_clauses->push_back(cl8);
sMM->cls->push_back (cl8);
	
	Clause* cl9 = new Clause (T1);
	cl9->addAtomRef(T1->therm_mode_unknown, true);
	cl9->addAtomRef(T1->therm_mode_stuck_on, true);
	cl9->setInternal(1);
	T1->therm_mode->internal_clauses->push_back(cl9);
sMM->cls->push_back (cl9);
	
	Clause* cl10 = new Clause (T1);
	cl10->addAtomRef(T1->therm_mode_unknown, true);
	cl10->addAtomRef(T1->therm_mode_stuck_off, true);
	cl10->setInternal(1);
	T1->therm_mode->internal_clauses->push_back(cl10);
sMM->cls->push_back (cl10);
	
	Clause* cl11 = new Clause (T1);
	cl11->addAtomRef(T1->therm_mode_unknown, false);
	cl11->addAtomRef(T1->therm_mode_stuck_off, false);
	cl11->addAtomRef(T1->therm_mode_stuck_on, false);
	cl11->addAtomRef(T1->therm_mode_on, false);
	cl11->addAtomRef(T1->therm_mode_off, false);
	cl11->setInternal(1);
	T1->therm_mode->internal_clauses->push_back(cl11);
sMM->cls->push_back (cl11);
	
	Clause* cl12 = new Clause (R1);
	cl12->addAtomRef(R1->room_cmdin_open, true);
	cl12->addAtomRef(R1->room_cmdin_none, true);
	cl12->setInternal(1);
	R1->room_cmdin->internal_clauses->push_back(cl12);
sMM->cls->push_back (cl12);
	
	Clause* cl13 = new Clause (R1);
	cl13->addAtomRef(R1->room_cmdin_close, true);
	cl13->addAtomRef(R1->room_cmdin_none, true);
	cl13->setInternal(1);
	R1->room_cmdin->internal_clauses->push_back(cl13);
sMM->cls->push_back (cl13);
	
	Clause* cl14 = new Clause (R1);
	cl14->addAtomRef(R1->room_cmdin_close, true);
	cl14->addAtomRef(R1->room_cmdin_open, true);
	cl14->setInternal(1);
	R1->room_cmdin->internal_clauses->push_back(cl14);
sMM->cls->push_back (cl14);
	
	Clause* cl15 = new Clause (R1);
	cl15->addAtomRef(R1->room_cmdin_close, false);
	cl15->addAtomRef(R1->room_cmdin_open, false);
	cl15->addAtomRef(R1->room_cmdin_none, false);
	cl15->setInternal(1);
	R1->room_cmdin->internal_clauses->push_back(cl15);
sMM->cls->push_back (cl15);
	
	Clause* cl16 = new Clause (R1);
	cl16->addAtomRef(R1->room_c1_c11, true);
	cl16->addAtomRef(R1->room_c1_c12, true);
	cl16->setInternal(1);
	R1->room_c1->internal_clauses->push_back(cl16);
sMM->cls->push_back (cl16);
	
	Clause* cl17 = new Clause (R1);
	cl17->addAtomRef(R1->room_c1_c10, true);
	cl17->addAtomRef(R1->room_c1_c12, true);
	cl17->setInternal(1);
	R1->room_c1->internal_clauses->push_back(cl17);
sMM->cls->push_back (cl17);
	
	Clause* cl18 = new Clause (R1);
	cl18->addAtomRef(R1->room_c1_c10, true);
	cl18->addAtomRef(R1->room_c1_c11, true);
	cl18->setInternal(1);
	R1->room_c1->internal_clauses->push_back(cl18);
sMM->cls->push_back (cl18);
	
	Clause* cl19 = new Clause (R1);
	cl19->addAtomRef(R1->room_c1_c10, false);
	cl19->addAtomRef(R1->room_c1_c11, false);
	cl19->addAtomRef(R1->room_c1_c12, false);
	cl19->setInternal(1);
	R1->room_c1->internal_clauses->push_back(cl19);
sMM->cls->push_back (cl19);
	
	Clause* cl20 = new Clause (R1);
	cl20->addAtomRef(R1->room_mode_open, true);
	cl20->addAtomRef(R1->room_mode_closed, true);
	cl20->setInternal(1);
	R1->room_mode->internal_clauses->push_back(cl20);
sMM->cls->push_back (cl20);
	
	Clause* cl21 = new Clause (R1);
	cl21->addAtomRef(R1->room_mode_unknown, true);
	cl21->addAtomRef(R1->room_mode_closed, true);
	cl21->setInternal(1);
	R1->room_mode->internal_clauses->push_back(cl21);
sMM->cls->push_back (cl21);
	
	Clause* cl22 = new Clause (R1);
	cl22->addAtomRef(R1->room_mode_unknown, true);
	cl22->addAtomRef(R1->room_mode_open, true);
	cl22->setInternal(1);
	R1->room_mode->internal_clauses->push_back(cl22);
sMM->cls->push_back (cl22);
	
	Clause* cl23 = new Clause (R1);
	cl23->addAtomRef(R1->room_mode_unknown, false);
	cl23->addAtomRef(R1->room_mode_open, false);
	cl23->addAtomRef(R1->room_mode_closed, false);
	cl23->setInternal(1);
	R1->room_mode->internal_clauses->push_back(cl23);
sMM->cls->push_back (cl23);
	/* cross-reference code */
	T1->imported_comps->push_back (R1);
	T1->i_i1->effet = R1->xdq;
		T1->therm_stf4->addAtom (R1->room_c1_c12, 1);
	T1->therm_t2->refAtomPre (1, R1->room_c1_c12);
	T1->therm_stf6->addAtom (R1->room_c1_c10, 1);
	T1->therm_t3->refAtomPre (1, R1->room_c1_c10);
	T1->therm_stf14->addAtom (R1->room_c1_c10, 0);
	T1->therm_t7->refAtomPre (0, R1->room_c1_c10);
	T1->therm_stf16->addAtom (R1->room_c1_c12, 0);
	T1->therm_t8->refAtomPre (0, R1->room_c1_c12);
	T1->therm_stf18->addAtom (R1->room_c1_c12, 1);
	T1->therm_t9->refAtomPre (1, R1->room_c1_c12);
	T1->therm_stf20->addAtom (R1->room_c1_c10, 1);
	T1->therm_t10->refAtomPre (1, R1->room_c1_c10);
R1->imported_comps->push_back (T1);
	R1->c_9->op1=T1->c_4;
	R1->c_9->op2=T1->c_1;
	R1->j_3[0] = T1->i_i1;
	
	dico = (variable*) new_malloc (10*sizeof (variable));
	dico[0] = T1->h;
	dico[1] = R1->xd;
	dico[2] = R1->x;
	dico[3] = R1->xdq;
	dico[4] = R1->xext;
	dico[5] = R1->Qc;
	dico[6] = R1->Qo;
	dico[7] = R1->m;
	dico[8] = R1->M;
	dico[9] = R1->un;
	
	display = (variable*) new_malloc (2*sizeof (variable));
	display[0] = R1->xd;
	display[1] = R1->x;
	dinfval = (double*) new_malloc (2*sizeof(double));
	dsupval = (double*) new_malloc (2*sizeof(double));
	
	measure = (variable*) new_malloc (1*sizeof (variable));
	measure[0] = R1->xd;
	mesval = NULL;
	lowalarm = (long*) new_malloc(1*sizeof (long));
	highalarm = (long*) new_malloc(1*sizeof (long));
	meslowmisb = (long*) new_malloc(1*sizeof (long));
	meshighmisb = (long*) new_malloc(1*sizeof (long));
	mesmisb = (long*) new_malloc(1*sizeof (long));
	temporal = (variable*) new_malloc (1*sizeof (variable));
	temporal[0] = R1->x;
	untemporal = (variable*) new_malloc (2*sizeof (variable));
	untemporal[0] = R1->xdq;
	untemporal[1] = R1->xd;
	
	influ = (influence*) new_malloc (7*sizeof (influence));
	influ[0] = T1->i_i1;
	influ[1] = R1->i_i1;
	influ[2] = R1->i_i2;
	influ[3] = R1->i_i3;
	influ[4] = R1->i_i4;
	influ[5] = R1->i_i5;
	influ[6] = R1->i_i6;
	condin = (long*) new_malloc (7*sizeof (long));
	condout = (long*) new_malloc (7*sizeof (long));
	condi = (condition*) new_malloc (16*sizeof (condition));
	condi[0] = T1->c_1;
	condi[1] = T1->c_2;
	condi[2] = T1->c_3;
	condi[3] = T1->c_4;
	condi[4] = T1->c_5;
	condi[5] = T1->c_6;
	condi[6] = R1->c_5;
	condi[7] = R1->c_2;
	condi[8] = R1->c_3;
	condi[9] = R1->c_4;
	condi[10] = R1->c_1;
	condi[11] = R1->c_6;
	condi[12] = R1->c_7;
	condi[13] = R1->c_8;
	condi[14] = R1->c_9;
	condi[15] = R1->c_10;
	cG = (cGraph*) new_malloc (6*sizeof (cGraph));
	cG[0] = T1->therm_n_1;
	cG[1] = R1->room_n_1;
	cG[2] = R1->room_n_2;
	cG[3] = R1->room_n_3;
	cG[4] = R1->room_n_4;
	cG[5] = R1->room_n_9;
	init = (initVar*) new_malloc (1*sizeof (initVar));
	init[0] = R1->h_1;
	gV = (gVar*) new_malloc (1*sizeof (gVar));
	gV[0] = R1->f_0;
	aC = (expr*) new_malloc (4*sizeof (expr));
	aC[0] = R1->s_1;
	aC[1] = R1->s_4;
	aC[2] = R1->s_6;
	aC[3] = R1->s_9;
	long* vals = (long*) new_malloc (4*sizeof (long));
	vals[1] = 0;
	vals[2] = 0;
	vals[3] = 0;
	long* inAc = (long*) new_malloc (4*sizeof (long));
	inAc[0] = 0;
	inAc[1] = 0;
	inAc[2] = 0;
	inAc[3] = 0;
	therm_rt = (runtime) new_malloc (sizeof (s_runtime));
	therm_rt->appli = "therm";
	therm_rt->num = 0;
	therm_rt->ts = 1;
	therm_rt->dts = 0;
	therm_rt->twc = 300;
	therm_rt->nvar = 10;
	therm_rt->dico = dico;
	therm_rt->nin = 0;
	therm_rt->in = NULL;
	therm_rt->inval = NULL;
	therm_rt->ndisp = 2;
	therm_rt->disp = display;
	therm_rt->dispinfval = dinfval;
	therm_rt->dispsupval = dsupval;
	therm_rt->ndispall = 0;
	therm_rt->dispall = NULL;
	therm_rt->nmes = 1;
	therm_rt->mes = measure;
	therm_rt->mesval = mesval;
	therm_rt->lowalarm = lowalarm;
	therm_rt->highalarm = highalarm;
	therm_rt->lowmisb = meslowmisb;
	therm_rt->highmisb = meshighmisb;
	therm_rt->misb = mesmisb;
	therm_rt->ntemp = 1;
	therm_rt->temp = temporal;
	therm_rt->nuntemp = 2;
	therm_rt->untemp = untemporal;
	therm_rt->nifl = 7;
	therm_rt->infl = influ;
	therm_rt->condin = condin;
	therm_rt->condout = condout;
	therm_rt->ncg = 6;
	therm_rt->cg = cG;
	therm_rt->maxDepth = 2;
	therm_rt->nit = 1;
	therm_rt->iv = init;
	therm_rt->ngv = 1;
	therm_rt->vgv = gV;
	therm_rt->ngc = 0;
	therm_rt->glc = NULL;
	therm_rt->inag = NULL;
	therm_rt->ncdc = 4;
	therm_rt->cdc = aC;
	therm_rt->valSpc = vals;
	therm_rt->inac = inAc;
	therm_rt->mfc = 0;
	therm_rt->mfc = NULL;
	therm_rt->inited = 0;
	therm_rt->runGC = 0;
	therm_rt->cumTime = 0;
	therm_rt->prec = 0;
	therm_rt->onlyFaultIso = 0;
	therm_rt->numMisb = 0;
	therm_rt->numOk = 0;
	therm_rt->mbVA = NULL;
	therm_rt->okVA = NULL;
	therm_rt->sfVA = NULL;
	therm_rt->oldNumMisb = 0;
	therm_rt->oldMisbVarArray = NULL;
	therm_rt->numNodesHST = 0;therm_rt->ncondi = 16;
	therm_rt->condi = condi;
	therm_rt->bridgeEvents = NULL;
	therm_rt->bridgeConds = NULL;
	therm_rt->bridgeTransitions = NULL;therm_rt->bridgeConflicts = NULL;
	createLeafListcaen (&therm_rt->HSTree);
	createConflictSet (&therm_rt->softConflictListcaen);
	therm_rt->diagOut = NULL;
	
/* remove next line if linking several applications 		       together */
koala_rt=therm_rt;
	}
bool env_opti = 1;
long guards_int = 1;
	int Trajectory::twd = 5;
	long h_pi = 0;
	string model_name = "therm";
	