#include "vdu.h"

vdu::vdu(string na, vector<CommandVar*>* in, vector<CommandVar*>* out) : Comp(na) {
		cmd_in = in;
		cmd_out = out;
	init();
}
vdu::~vdu() {

}
void vdu::init() {

	set<string> vdu_cmdin_values;
	vdu_cmdin_values.insert("close");
	vdu_cmdin_values.insert("none");
	vdu_cmdin_values.insert("off");
	vdu_cmdin_values.insert("on");
	vdu_cmdin_values.insert("open");
	vdu_cmdin_values.insert("reset");
	string cmdinname = name + ".cmdin";
	vdu_cmdin = new CommandVar(cmdinname, vdu_cmdin_values, "none", this);
		addStateVar(vdu_cmdin);

	vdu_cmdin_none = new Atom(vdu_cmdin, "none", name + ".cmdin=none");
		(*atoms)["vdu_cmdin_none"]=vdu_cmdin_none;
		vdu_cmdin_on = new Atom(vdu_cmdin, "on", name + ".cmdin=on");
		(*atoms)["vdu_cmdin_on"]=vdu_cmdin_on;
		vdu_cmdin_off = new Atom(vdu_cmdin, "off", name + ".cmdin=off");
		(*atoms)["vdu_cmdin_off"]=vdu_cmdin_off;
		vdu_cmdin_open = new Atom(vdu_cmdin, "open", name + ".cmdin=open");
		(*atoms)["vdu_cmdin_open"]=vdu_cmdin_open;
		vdu_cmdin_close = new Atom(vdu_cmdin, "close", name + ".cmdin=close");
		(*atoms)["vdu_cmdin_close"]=vdu_cmdin_close;
		vdu_cmdin_reset = new Atom(vdu_cmdin, "reset", name + ".cmdin=reset");
		(*atoms)["vdu_cmdin_reset"]=vdu_cmdin_reset;
		cmd_out = new vector<CommandVar*>();
	cmd_out->push_back (vdu_cmdin);
	
	set<string> vdu_cmdout_values;
	vdu_cmdout_values.insert("close");
	vdu_cmdout_values.insert("none");
	vdu_cmdout_values.insert("open");
	string cmdoutname = name + ".cmdout";
	vdu_cmdout = new CommandVar(cmdoutname, vdu_cmdout_values, "none", this);
		addStateVar(vdu_cmdout);

	vdu_cmdout_none = new Atom(vdu_cmdout, "none", name + ".cmdout=none");
		(*atoms)["vdu_cmdout_none"]=vdu_cmdout_none;
		vdu_cmdout_open = new Atom(vdu_cmdout, "open", name + ".cmdout=open");
		(*atoms)["vdu_cmdout_open"]=vdu_cmdout_open;
		vdu_cmdout_close = new Atom(vdu_cmdout, "close", name + ".cmdout=close");
		(*atoms)["vdu_cmdout_close"]=vdu_cmdout_close;
		cmd_out = new vector<CommandVar*>();
	cmd_out->push_back (vdu_cmdout);
	
	set<string> vdu_mode_values;
	vdu_mode_values.insert("failed");
	vdu_mode_values.insert("off");
	vdu_mode_values.insert("on");
	vdu_mode_values.insert("unknown");
	string modename = name + ".mode";
	vdu_mode = new ModeVar(modename, vdu_mode_values, "off", this);
		addStateVar(vdu_mode);

	vdu_mode_off = new Atom(vdu_mode, "off", name + ".mode=off");
		(*atoms)["vdu_mode_off"]=vdu_mode_off;
		vdu_mode_on = new Atom(vdu_mode, "on", name + ".mode=on");
		(*atoms)["vdu_mode_on"]=vdu_mode_on;
		vdu_mode_failed = new Atom(vdu_mode, "failed", name + ".mode=failed");
		(*atoms)["vdu_mode_failed"]=vdu_mode_failed;
		vdu_mode_unknown = new Atom(vdu_mode, "unknown", name + ".mode=unknown");
		(*atoms)["vdu_mode_unknown"]=vdu_mode_unknown;
	c_1 = mkCond ();
	setCondType (c_1, 6);
	setCondCTE (c_1, 0);
	setCondAtom (c_1, vdu_mode_off);
	;
	c_2 = mkCond ();
	setCondType (c_2, 6);
	setCondCTE (c_2, 0);
	setCondAtom (c_2, vdu_mode_on);
	;
	c_3 = mkCond ();
	setCondType (c_3, 6);
	setCondCTE (c_3, 0);
	setCondAtom (c_3, vdu_mode_failed);
	;
	c_4 = mkCond ();
	setCondType (c_4, 6);
	setCondCTE (c_4, 0);
	setCondAtom (c_4, vdu_mode_unknown);
	;
		vdu_mode->conditions->insert(pair<const char*, int>(vdu_mode_off->getId(), 8));
	vdu_mode_off->cond = 1;
		vdu_mode->conditions->insert(pair<const char*, int>(vdu_mode_on->getId(), 9));
	vdu_mode_on->cond = 1;
		vdu_mode->conditions->insert(pair<const char*, int>(vdu_mode_failed->getId(), 10));
	vdu_mode_failed->cond = 1;
		vdu_mode->conditions->insert(pair<const char*, int>(vdu_mode_unknown->getId(), 11));
	vdu_mode_unknown->cond = 1;
		external_clauses = new vector<Clause*>();

	vdu_stf32 = new StateFormula();
	vdu_stf32->addAtom (vdu_mode_off, 1);
 /* gen */
	vdu_stf32->setOperat("");

	vdu_stf33 = new StateFormula();
	vdu_stf33->addAtom (vdu_mode_failed, 1);
 /* gen */
	vdu_stf33->setOperat("");

	vdu_t8 = new Transition(vdu_stf32, vdu_stf33, "Fail", 0.1, 0, 0);
vdu_t8->trans_id = 16;
	
	addTransitionToC(vdu_t8);
	
	vdu_stf34 = new StateFormula();
	vdu_stf34->addAtom (vdu_mode_on, 1);
 /* gen */
	vdu_stf34->setOperat("");

	vdu_stf35 = new StateFormula();
	vdu_stf35->addAtom (vdu_mode_failed, 1);
 /* gen */
	vdu_stf35->setOperat("");

	vdu_t9 = new Transition(vdu_stf34, vdu_stf35, "Fail", 0.1, 0, 0);
vdu_t9->trans_id = 17;
	
	addTransitionToC(vdu_t9);
	
	vdu_stf36 = new StateFormula();
	vdu_stf36->addAtom (vdu_mode_unknown, 1);
 /* gen */
	vdu_stf36->setOperat("");

	vdu_stf37 = new StateFormula();
	vdu_stf37->addAtom (vdu_mode_unknown, 1);
 /* gen */
	vdu_stf37->setOperat("");

	vdu_t10 = new Transition(vdu_stf36, vdu_stf37, "Nominal", 1, 0, 1);
vdu_t10->trans_id = 18;
	
	addTransitionToC(vdu_t10);
	
	vdu_stf38 = new StateFormula();
	vdu_stf38->addAtom (vdu_mode_failed, 1);
 /* gen */
	vdu_stf38->addAtom (vdu_cmdin_reset, 0);
 /* gen */
	vdu_stf38->setOperat("and");

	vdu_stf39 = new StateFormula();
	vdu_stf39->addAtom (vdu_mode_failed, 1);
 /* gen */
	vdu_stf39->setOperat("");

	vdu_t11 = new Transition(vdu_stf38, vdu_stf39, "Nominal", 1, 0, 1);
vdu_t11->trans_id = 19;
	
	addTransitionToC(vdu_t11);
	
	vdu_stf40 = new StateFormula();
	vdu_stf40->addAtom (vdu_mode_off, 1);
 /* gen */
	vdu_stf40->addAtom (vdu_cmdin_reset, 0);
 /* gen */
	vdu_stf40->addAtom (vdu_cmdin_on, 0);
 /* gen */
	vdu_stf40->setOperat("and");

	vdu_stf41 = new StateFormula();
	vdu_stf41->addAtom (vdu_mode_off, 1);
 /* gen */
	vdu_stf41->setOperat("");

	vdu_t12 = new Transition(vdu_stf40, vdu_stf41, "Nominal", 0.99, 0, 1);
vdu_t12->trans_id = 20;
	
	addTransitionToC(vdu_t12);
	
	vdu_stf42 = new StateFormula();
	vdu_stf42->addAtom (vdu_mode_on, 1);
 /* gen */
	vdu_stf42->addAtom (vdu_cmdin_off, 0);
 /* gen */
	vdu_stf42->setOperat("and");

	vdu_stf43 = new StateFormula();
	vdu_stf43->addAtom (vdu_mode_on, 1);
 /* gen */
	vdu_stf43->setOperat("");

	vdu_t13 = new Transition(vdu_stf42, vdu_stf43, "Nominal", 1, 0, 1);
vdu_t13->trans_id = 21;
	
	addTransitionToC(vdu_t13);
	
	vdu_stf44 = new StateFormula();
	vdu_stf44->addAtom (vdu_cmdin_reset, 1);
 /* gen */
	vdu_stf44->addAtom (vdu_mode_off, 1);
 /* gen */
	vdu_stf44->setOperat("and");

	vdu_stf45 = new StateFormula();
	vdu_stf45->addAtom (vdu_mode_on, 1);
 /* gen */
	vdu_stf45->setOperat("");

	vdu_t14 = new Transition(vdu_stf44, vdu_stf45, "Nominal", 0.9, 0, 0);
vdu_t14->trans_id = 22;
	
	addTransitionToC(vdu_t14);
	
	vdu_stf46 = new StateFormula();
	vdu_stf46->addAtom (vdu_cmdin_reset, 1);
 /* gen */
	vdu_stf46->addAtom (vdu_mode_failed, 1);
 /* gen */
	vdu_stf46->setOperat("and");

	vdu_stf47 = new StateFormula();
	vdu_stf47->addAtom (vdu_mode_on, 1);
 /* gen */
	vdu_stf47->setOperat("");

	vdu_t15 = new Transition(vdu_stf46, vdu_stf47, "Nominal", 0.9, 0, 0);
vdu_t15->trans_id = 23;
	
	addTransitionToC(vdu_t15);
	
	vdu_stf48 = new StateFormula();
	vdu_stf48->addAtom (vdu_cmdin_off, 1);
 /* gen */
	vdu_stf48->addAtom (vdu_mode_on, 1);
 /* gen */
	vdu_stf48->setOperat("and");

	vdu_stf49 = new StateFormula();
	vdu_stf49->addAtom (vdu_mode_off, 1);
 /* gen */
	vdu_stf49->setOperat("");

	vdu_t16 = new Transition(vdu_stf48, vdu_stf49, "Nominal", 0.9, 0, 0);
vdu_t16->trans_id = 24;
	
	addTransitionToC(vdu_t16);
	
	vdu_stf50 = new StateFormula();
	vdu_stf50->addAtom (vdu_cmdin_on, 1);
 /* gen */
	vdu_stf50->addAtom (vdu_mode_off, 1);
 /* gen */
	vdu_stf50->setOperat("and");

	vdu_stf51 = new StateFormula();
	vdu_stf51->addAtom (vdu_mode_on, 1);
 /* gen */
	vdu_stf51->setOperat("");

	vdu_t17 = new Transition(vdu_stf50, vdu_stf51, "Nominal", 0.9, 0, 0);
vdu_t17->trans_id = 25;
	
	addTransitionToC(vdu_t17);
	
}
